<?php
/**
 * @link http://www.yiiframework.com/
 * @copyright Copyright (c) 2008 Yii Software LLC
 * @license http://www.yiiframework.com/license/
 */

namespace backend\assets;

use yii\web\AssetBundle;

/**
 * @author Qiang Xue <qiang.xue@gmail.com>
 * @since 2.0
 */
class AppAsset extends AssetBundle
{
    public $basePath = '@webroot/';
    public $baseUrl = '@web/web/themes/adminLTE/';
    public $css = [
        'css/bootstrapcdn_bootstrap.min.css',
        'css/bootstrapcdn_font-awesome.min.css',
        'css/ionicons.min.css',
        'css/font-awesome.min.css',
        '//code.ionicframework.com/ionicons/1.5.2/css/ionicons.min.css',
        "css/morris/morris.css",
        "css/datepicker/datepicker3.css",
        "css/daterangepicker/daterangepicker-bs3.css",
        "css/bootstrap-wysihtml5/bootstrap3-wysihtml5.min.css",
        "css/bootstrap-wysihtml5/bootstrap3-wysihtml5.min.css",
        
       
        "css/bootstrap/css/bootstrap.min.css",
        "css/bootstrap/css/bootstrap.css",
        'css/AdminLTE.min.css',
        'css/AdminLTE.css',
        'css/customize.css',
        'css/skins/_all-skins.min.css',
        'css/skins/_all-skins.css',
        'css/skins/skin-black.min.css',
        'css/skins/skin-black.css',
        'css/skins/skin-green.min.css',
        'css/skins/skin-green.css',
        'css/skins/skin-purple.min.css',
        'css/skins/skin-purple.css',
        'css/skins/skin-blue.min.css',
        'css/skins/skin-blue.css',
        'css/skins/skin-red.min.css',
        'css/skins/skin-red.css',
        'css/skins/skin-yellow.min.css',
        'css/skins/skin-yellow.css',
        
        "js/plugins/morris/morris.css",
        "css/multi-select.css",
        "css/tipsy.css",
        

        #"css/site.css",
    ];
    public $js = [
        "js/AdminLTE/bootstrapcdn.min.js",
        "js/AdminLTE/bootstrap.min.js",
        
//        "js/plugins/morris/morris.min.js",
        "js/AdminLTE/jquery-ui.min.js",
        
       
        //"https://cdnjs.cloudflare.com/ajax/libs/raphael/2.1.0/raphael-min.js",
      
        "js/plugins/sparkline/jquery.sparkline.min.js",
        "js/plugins/jvectormap/jquery-jvectormap-1.2.2.min.js",
        "js/plugins/jvectormap/jquery-jvectormap-world-mill-en.js",
        "js/plugins/jqueryKnob/jquery.knob.js",
        "js/plugins/daterangepicker/daterangepicker.js",
      //  "js/plugins/datepicker/bootstrap-datepicker.js",
        "js/plugins/bootstrap-wysihtml5/bootstrap3-wysihtml5.all.min.js",
        "js/plugins/iCheck/icheck.min.js",
        'js/AdminLTE/required.js',
        //"js/AdminLTE/app.js",
        "js/plugins/chartjs/Chart.js",
        "js/AdminLTE/invent.js",
         "js/AdminLTE/jquery.quicksearch.js",
        
        "js/AdminLTE/jquery.multi-select.js",
         "js/AdminLTE/break.js",
         "js/AdminLTE/timeLogs.js",
         //"js/AdminLTE/bootbox.js",
        "js/AdminLTE/bootbox.min.js",
        "js/AdminLTE/jquery.tipsy.js",
        
//        "js/AdminLTE/app.js",
       // "js/AdminLTE/dashboard.js",
//        "js/AdminLTE/demo.js",
//         

    ];
    public $depends = [
        'yii\web\YiiAsset',
        'yii\bootstrap\BootstrapAsset',
    ];
}