<?php
namespace backend\controllers;
use Yii;
use backend\models\Orders;
use backend\models\OrdersSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\web\Session;
class ReportsController extends Controller
{
    public function behaviors()
    {
        return [
               'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['test'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['profit','payment'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }
     public function beforeAction($action)
    {
        if (!parent::beforeAction($action)) {
            return false;
        }
        // Check only when the user is logged in
        if ( !Yii::$app->user->isGuest)  { 
            
            $time=\Yii::$app->session->get('userSessionTimeout');
            
            if ($time < time()) {
                Yii::$app->user->logout();
            } else {
                \Yii::$app->session->set('userSessionTimeout',time() + Yii::$app->params['sessionTimeoutSeconds']);      
                return true; 
            }
        } else {
            return true;
        }
    }
     public function actionPayment(){ 
         $models = Orders::find()->where(['Status' => 'PAYMENT RECEIVED'])->all();  
         $notspecified=$other=$plum=$spark=$paid=array();
         $paidamount=$sparkamount=$plumamount=$otheramount=$notspecifiedamount=0;
         if(!empty($models)){
             foreach($models as $model){               
                 if($model->CreditCard=="PAID"){
                     if(!empty($model->Cost)) {
                     $paid[$model->OrderId]=$model->Cost;
                     }
                 }elseif($model->CreditCard=="SPARK"){
                     if(!empty($model->Cost)) {
                     $spark[$model->OrderId]=$model->Cost;
                     }
                 }elseif($model->CreditCard=="PLUM"){
                     if(!empty($model->Cost)) {
                     $plum[$model->OrderId]=$model->Cost;
                     }
                 }elseif($model->CreditCard=="OTHER"){
                     if(!empty($model->Cost)) {
                     $other[$model->OrderId]=$model->Cost;
                     }
                 }else{
                     if(!empty($model->Cost)) { 
                        $notspecified[$model->OrderId]=$model->Cost; 
                     }
                 }               
             }
             $paidamount=array_sum($paid);
             $sparkamount=array_sum($spark);
             $plumamount=array_sum($plum);
             $otheramount=array_sum($other);
             $notspecifiedamount=array_sum($notspecified);
             //echo '<pre>';print_r($paid); print_r($spark); print_r($plum); print_r($other); print_r($notspecified); echo '</pre>';
         }
         $data=array();
         
         $data['SPARK']=$sparkamount;
         $data['PLUM']=$plumamount;
         $data['PAID']=$paidamount;
         $data['OTHER']=$otheramount;
         $data['NOT SPECIFIED']=$notspecifiedamount;
          return $this->render('payment', [
            'model' => $data,           
        ]);
        
        // 
     }
     public function actionProfit(){ 
       $mysourceorder= $mysource_profit=$mysource_sale=$mysource_cost=array();
         $final_array=array();
         if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }
       //  $query = Orders::find()->where('Status != :status AND Status!=:ss', [':status' => 'DELETED',':ss'=>'TRASH'])->orderBy(['EventDate' => SORT_ASC])->all();  
         $query = Orders::find();  
         if(!empty($from) && empty($to)) {
              $query->andFilterWhere(['>=', 'OrderDate',$from]);
         }else if(!empty($to) && empty($from)) { 
               $query->andFilterWhere(['<=', 'OrderDate',$to]);
          } else if(!empty($to) && !empty($from)){ 
               $query->andFilterWhere(['>=', 'OrderDate', $from])
                ->andFilterWhere(['<=', 'OrderDate', $to]);
          }else{
              $query->andFilterWhere(['=', 'OrderDate', '1800-01-01']);
          }
           $records=$query->all();
          if(!empty($records)){
              $records=$query->all();
             
              foreach($records as $signlerecord){
                  if($signlerecord->Status!="TRASH" && $signlerecord->Status!="DELETED") { 
                        if(!empty($signlerecord->Cost)) {
                          $mysource_cost[$signlerecord->Source][]=$signlerecord->Cost;
                          $mysource_sale[$signlerecord->Source][]=$signlerecord->SalePrice;
                          $mysource_profit[$signlerecord->Source][]=$signlerecord->Profit;
                        }     
                        $mysourceorder[$signlerecord->Source][]=$signlerecord->OrderId;
                }               
              }
             
              if(!empty($mysource_cost)) {
                  foreach($mysource_cost as $key=>$cost) {
                      $final_array[$key]['cost']=array_sum($cost);                      
                  }
              }
              if(!empty($mysource_sale)) {
                  foreach($mysource_sale as $key1=>$sale) {
                      $final_array[$key1]['sale']=array_sum($sale);                      
                  }
              }
              if(!empty($mysource_profit)){
                  foreach($mysource_profit as $key2=>$profit) {                   
                      $final_array[$key2]['profit']=array_sum($profit);                      
                  }
              }  
              if(!empty($mysourceorder)) {
                  foreach($mysourceorder as $key3=>$order) {                   
                      $final_array[$key3]['myorder']=count($order);                      
                  }
              }
             
          }
          
         
         
         return $this->render('profit', [
            'from' => $from, 
            'to' => $to, 
            'finaldata' => $final_array, 
             
        ]);
         
     }
}
?>