<?php

namespace backend\models;

use Yii;

/**
 * This is the model class for table "orders".
 *
 * @property integer $OrderId
 * @property string $OrderDate
 * @property integer $OrderMainId
 * @property string $Quantity
 * @property string $Event
 * @property string $Venue
 * @property string $Section
 * @property string $Row
 * @property string $EventDate
 * @property string $Cost
 * @property string $SalePrice
 * @property string $Profit
 * @property string $Source
 * @property string $CreditCard
 * @property string $Notes
 * @property string $Status
 * @property string $Link
 * @property string $UpdateBy
 * @property string $message_id
 * @property string $Updated_at
 * @property string $Created_at
 */
class Orders extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'orders';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
          // [['OrderMainId'], 'integer'],
            [['Status'], 'required','on' => 'update'],
            [['Notes'], 'string'],
            [['Updated_at', 'Created_at'], 'safe'],
            [['OrderDate', 'OrderMainId','Quantity', 'Event', 'Venue', 'Section', 'Row', 'EventDate', 'Cost', 'SalePrice', 'Source', 'CreditCard', 'Status', 'message_id','Othertype','Link','UpdateBy'], 'string', 'max' => 255]
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'OrderId' => 'Order ID',
            'OrderDate' => 'Order Date',
            'OrderMainId' => 'Order #',
            'Quantity' => 'Quantity',
            'Event' => 'Event',
            'Venue' => 'Venue',
            'Section' => 'Section',
            'Row' => 'Row',
            'EventDate' => 'Event Date',
            'Cost' => 'Cost',
            'SalePrice' => 'Sale Price',
            'Profit' => 'Profit',
            'Source' => 'Source',
            'CreditCard' => 'Credit Card',
            'Notes' => 'Notes',
            'Status' => 'Status',
            'Othertype'=>"Other",
            'Link'=>'Link',
             'UpdateBy' => 'Update By',
            'message_id' => 'Message ID',
            'Updated_at' => 'Updated At',
            'Created_at' => 'Created At',
        ];
    }
    
    public static function getstatus(){
          $array = array(
                        'LINKS TO ADD' => 'LINKS TO ADD',
                        'TO BUY' => 'TO BUY',
                        'WAITING PAYMENT' => 'WAITING PAYMENT',
                        'PAYMENT RECEIVED'=>'PAYMENT RECEIVED',
                        'COMPLETED'=>'COMPLETED',
                        'DELAYED'=>'DELAYED',
                        'TO SHIP'=>'TO SHIP',
                        'PRESALE'=>'PRESALE',
                        'SOLD OUT'=>'SOLD OUT',
                        'PROBLEM'=>'PROBLEM',
                        'BOUGHT'=>'BOUGHT',
                        'CANCELLED'=>'CANCELLED',
                       // 'TRASH'=>'TRASH'
                        );
          return $array;
    }
    public static function getcards(){
          $array = array(
                        'SPARK' => 'SPARK',
                        'PLUM' => 'PLUM',
                        'PAID' => 'PAID',
                        'OTHER'=>'OTHER',                      
                        );
          return $array;
    }
    
}
