<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\Orders;

/**
 * OrdersSearch represents the model behind the search form about `app\models\Orders`.
 */
class OrdersSearch extends Orders
{
    /**
     * @inheritdoc
     */
    
    public function rules()
    {
        return [
            [['OrderId'], 'integer'],
            [['OrderMainId','OrderDate', 'Quantity', 'Event', 'Venue', 'Section', 'Row', 'EventDate', 'Cost', 'SalePrice', 'Profit', 'Source', 'CreditCard', 'Notes', 'Status', 'message_id', 'Updated_at', 'Created_at','Link'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where('Status != :status', [':status' => 'DELETED']);   
        }else{
            $query = Orders::find()->where('Status != :status', [':status' => 'DELETED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 100,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
            ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchbuy($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'TO BUY']);   
        }else{
            $query = Orders::find()->where(['Status' => 'TO BUY'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    public function searchwaiting($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'WAITING PAYMENT']);   
        }else{
            $query = Orders::find()->where(['Status' => 'WAITING PAYMENT'])->orderBy(['Updated_at' => SORT_DESC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    public function searchpayment($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PAYMENT RECEIVED']);   
        }else{
            $query = Orders::find()->where(['Status' => 'PAYMENT RECEIVED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchcompleted($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'COMPLETED']);   
        }else{
            $query = Orders::find()->where(['Status' => 'COMPLETED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
    public function searchdelayed($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'DELAYED']);   
        }else{
            $query = Orders::find()->where(['Status' => 'DELAYED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchtoship($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'TO SHIP']);   
        }else{
            $query = Orders::find()->where(['Status' => 'TO SHIP'])->orderBy(['Updated_at' => SORT_DESC]);
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
    public function searchpresale($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PRESALE']);   
        }else{
            $query = Orders::find()->where(['Status' => 'PRESALE'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchsoldout($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'SOLD OUT']);   
        }else{
            $query = Orders::find()->where(['Status' => 'SOLD OUT'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    public function searchproblem($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PROBLEM']);   
        }else{
            $query = Orders::find()->where(['Status' => 'PROBLEM'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchbought($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'BOUGHT']);   
        }else{
            $query = Orders::find()->where(['Status' => 'BOUGHT'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
     public function searchcancelled($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'CANCELLED']);   
        }else{
            $query = Orders::find()->where(['Status' => 'CANCELLED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    
    public function searchLinks($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'LINKS TO ADD']);   
        }else{
            $query = Orders::find()->where(['Status' => 'LINKS TO ADD'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
    public function searchTrash($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'TRASH']);   
        }else{
            $query = Orders::find()->where(['Status' => 'TRASH'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'CreditCard', $this->CreditCard])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id]);

        return $dataProvider;
    }
}
