<?php

use yii\helpers\Html;
use yii\grid\GridView;
use backend\models\Orders;
use yii\web\Request;
use yii\helpers\Url;
use yii\web\View;
/* @var $this yii\web\View */
/* @var $searchModel app\models\OrdersSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$action = Yii::$app->controller->action->id; 
if($action=="buy"){
   $this->title = "Orders To Buy"; 
}elseif($action=="waiting"){
    $this->title = "Orders Waiting Payment";  
}elseif($action=="payment"){
    $this->title = "Orders Payment Received";  
}elseif($action=="completed"){
    $this->title = "Orders Completed";  
}elseif($action=="delayed"){
    $this->title = "Orders Delayed";  
}elseif($action=="toship"){
    $this->title = "Orders To Ship";  
}elseif($action=="presale"){
    $this->title = "Orders Presale";  
}elseif($action=="soldout"){
    $this->title = "Orders Sold Out";  
}elseif($action=="problem"){
    $this->title = "Orders Problem";  
}elseif($action=="bought"){
    $this->title = "Orders Bought";  
}elseif($action=="cancelled"){
    $this->title = "Orders Cancelled";  
}elseif($action=="links"){
    $this->title = "Orders Links to add";  
}elseif($action=="trash"){
    $this->title = "Orders Trash";  
}
else{
     $this->title = "Orders";
}



$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .table>caption+thead>tr:first-child>td, .table>caption+thead>tr:first-child>th, .table>colgroup+thead>tr:first-child>td, .table>colgroup+thead>tr:first-child>th, .table>thead:first-child>tr:first-child>td, .table>thead:first-child>tr:first-child>th{
        color:#398EC6
    }
.table > tbody > tr.info > td {max-width:300px;
word-wrap:break-word;}
    .alert{margin-top: 10px; float: left; width: 100%; clear:both;}
    .form-control{padding: 0px !important}
    .table > thead > tr > td.danger, .table > tbody > tr > td.danger, .table > tfoot > tr > td.danger, .table > thead > tr > th.danger, .table > tbody > tr > th.danger, .table > tfoot > tr > th.danger, .table > thead > tr.danger > td, .table > tbody > tr.danger > td, .table > tfoot > tr.danger > td, .table > thead > tr.danger > th, .table > tbody > tr.danger > th, .table > tfoot > tr.danger > th{
        background: #f4eca9 !important
    }
</style>
<div class="orders-index">
    <div class="col-md-10">
<div style="overflow-x:auto;">
    <h1><?= Html::encode($this->title) ?></h1>
 

    <p>
        
<?php   if($action=="buy"){
  echo Html::a('Refresh', ['buy'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="waiting"){
 echo Html::a('Refresh', ['waiting'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="payment"){
  echo Html::a('Refresh', ['payment'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="completed"){
  echo Html::a('Refresh', ['completed'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="delayed"){
   echo Html::a('Refresh', ['delayed'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="toship"){
   echo Html::a('Refresh', ['toship'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="presale"){
   echo Html::a('Refresh', ['presale'], ['class' => 'pull-right btn btn-success']);
}elseif($action=="soldout"){
    echo Html::a('Refresh', ['soldout'], ['class' => 'pull-right btn btn-success']);    
}elseif($action=="problem"){
    echo Html::a('Refresh', ['problem'], ['class' => 'pull-right btn btn-success']);    
}elseif($action=="bought"){
   echo Html::a('Refresh', ['bought'], ['class' => 'pull-right btn btn-success']);   
}elseif($action=="links"){
   echo Html::a('Refresh', ['links'], ['class' => 'pull-right btn btn-success']);   
}elseif($action=="trash"){
   echo Html::a('Refresh', ['trash'], ['class' => 'pull-right btn btn-success']);   
}elseif($action=="index"){
   echo Html::a('Refresh', ['index'], ['class' => 'pull-right btn btn-success']);   
}
else{
      echo Html::a('Reset', ['index'], ['class' => 'pull-right btn btn-success']);   
}
?>  
        
        <?php  $count = $dataProvider->getCount();     
    
        if(!empty($count)) { ?>
        <a class="pull-left btn btn-success" href="<?php echo  Url::to(['orders/csv','status'=>$action]); //echo Yii::$app->request->url.'&action=csv'; ?>">Export CSV</a>        
   
        <?php if($action=="trash") { ?>
            <?php echo Html::a('Delete Permanently', 'javascript:void(0)', ['class' => 'btn btn-danger pull-left', 'onclick'=>'trash($("#user-grid").yiiGridView("getSelectedRows"))' ]); ?>
        <?php } ?>
        
        <span class="pull-right">
        <?php  
        
        echo Html::dropDownList('changestatus','', Orders::getstatus(),['prompt'=>'Please Select Status','id'=>'changestatus','class'=>'pull-left']);
        ?>
            <?php echo Html::a('Move', 'javascript:void(0)', ['class' => 'btn btn-primary pull-left', 'onclick'=>'del($("#user-grid").yiiGridView("getSelectedRows"))' ]); ?>
           
        </span>
 <?php } ?>
       
    </p>
     <?php if (Yii::$app->session->hasFlash('success')): ?>
        <div class="alert alert-success">
             <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            <?php echo Yii::$app->session->getFlash('success'); ?>
        </div>
     <?php endif; ?>
    <?php if (Yii::$app->session->hasFlash('error')): ?>
        <div class="alert alert-error">
             <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            <?php echo Yii::$app->session->getFlash('error'); ?>
        </div>

     <?php endif; ?>
<?php if(Yii::$app->user->identity->Role!='user') { ?>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => ''],
        'id'=>'user-grid',
        'rowOptions' => function ($model, $index, $widget, $grid){ 
       
            if($model->Profit>=0){
                 return ['class' => 'info'];
            }else if($model->Profit<0){
                 return ['class' => 'danger'];
            }
          },
        'columns' => [
            [
            'class' => 'yii\grid\CheckboxColumn',      
            ],
           // ['class' => 'yii\grid\SerialColumn'],
          
          //  'OrderId',
            //'OrderDate',
            [  
              'label'=>'Order Date',    
              'attribute'=>'OrderDate',
              'value'=> function($data){       
             // echo '<pre>'; print_r($data['OrderDate']); echo '</pre>';
                        if($data['OrderDate']!="0000:00:00"){
                                  return  date("m/d/Y",strtotime($data['OrderDate']));
                        }else{
                            return ' ';
                        }
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[OrderDate]',
                'attribute'=>'OrderDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control'
                ],
            ]), 
            ],
            'OrderMainId',
           
             [
                'attribute'=>'Quantity',
                'label'=>'Q',
                'value'=>function($data){           
                    return $data->Quantity;                    
                   },
            ],
            'Event',
            'Venue',
            'Section',
            'Row',            
            // 'EventDate',
             [  
              'label'=>'Event Date',    
              'attribute'=>'EventDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['EventDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[EventDate]',
                'attribute'=>'EventDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control'
                ],
            ]), 
            ],
            [
                'attribute'=>'Cost',
                'label'=>'Cost',
                'value'=>function($data){ 
                       if(!empty($data->Cost)) {
                            return "$". number_format($data->Cost,2);     
                          // return "$".$data->Cost;      
                       }
                    return ' ';                    
                   },
            ],
            [
                'attribute'=>'SalePrice',
                'label'=>'Sale Price',
                'value'=>function($data){ 
                       if(!empty($data->SalePrice)) {
                            return "$". number_format($data->SalePrice,2);   
                          // return "$".$data->SalePrice;      
                       }
                    return ' ';                    
                   },
            ],
            [
                'attribute'=>'Profit',
                'label'=>'Profit',
                'value'=>function($data){ 
                       if(!empty($data->Profit)) {
                           if($data->Profit>0){
                            return "$". number_format($data->Profit,2);  
                           }else{
                              // echo "herer";
                                return "-".str_replace("-","$",number_format($data->Profit,2));  
                           }
                       }
                    return ' ';                    
                   },
            ],
            // 'SalePrice',
            // 'Profit',
             'Source',
             [
                'attribute'=>'CreditCard',
                'filter'=> Orders::getcards(),
                'value'=>function($data){     
                       if(!empty($data->CreditCard)){
                            return $data->CreditCard;            
                       }else{
                           return '';  
                       }
                   },
            ],
            'Link',            
              
             'Notes:ntext',
             [
                'attribute'=>'Status',
                 'filter'=> Orders::getstatus(),
                 'value'=>function($data){           
                        if(!empty($data->Status)) {
                             return $data->Status; 
                        }else{
                            return ' ';    
                        }             
                    },
            ],           

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{update} {delete}',
            ],
        ],
]); }else{ ?>
    
 <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => ''],
        'id'=>'user-grid',
        'rowOptions' => function ($model, $index, $widget, $grid){ 
            if($model->Profit>=0){
                     return ['class' => 'info'];
                }else if($model->Profit<0){
                     return ['class' => 'danger'];
                }
          },
        'columns' => [
            [
            'class' => 'yii\grid\CheckboxColumn',      
            ],
           // ['class' => 'yii\grid\SerialColumn'],
          
          //  'OrderId',
            //'OrderDate',
            [  
              'label'=>'Order Date',    
              'attribute'=>'OrderDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['OrderDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[OrderDate]',
                'attribute'=>'OrderDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control'
                ],
            ]), 
            ],
            'OrderMainId',
           
             [
                'attribute'=>'Quantity',
                'label'=>'Q',
                'value'=>function($data){           
                    return $data->Quantity;                    
                   },
            ],
            'Event',
            'Venue',
            'Section',
            'Row',            
             //'EventDate',
            [  
              'label'=>'Event Date',    
              'attribute'=>'EventDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['EventDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[EventDate]',
                'attribute'=>'EventDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control'
                ],
            ]), 
            ],
             [
                'attribute'=>'Cost',
                'label'=>'Cost',
                'value'=>function($data){ 
                       if(!empty($data->Cost)) {
                            return "$". number_format($data->Cost,2);                                 
                       }
                    return ' ';                    
                   },
            ],
            // 'SalePrice',
             //'Profit',
             'Source',
             [
                'attribute'=>'CreditCard',
                'filter'=> Orders::getcards(),
                'value'=>function($data){           
                    if(!empty($data->CreditCard)){
                            return $data->CreditCard;            
                       }else{
                           return '';  
                       }            
                   },
            ],
             'Link', 
           /* [
                'label'=>'Notes',              
                'value' => function($data){
                    if(!empty($data->Notes)){
                    return $data->Notes;            
                    }else{
                        return '';  
                    }

                }
           ], */
             'Notes:ntext',
             [
                'attribute'=>'Status',
                 'filter'=> Orders::getstatus(),
                 'value'=>function($data){
                        if(!empty($data->Status)) {
                             return $data->Status; 
                        }else{
                            return ' ';    
                        }
                    },
            ],           

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{update} {delete}',
            ],
        ],
]); }
?>
</div>
</div>
</div>
<?php
 $this->registerJs("
$('#user-grid tr').each(function(index, tr) {
    var lines = $('td', tr).map(function(index, td) {
      // console.log(index+') '+$(td).text())
      if(index==1){
        if($(td).text()=='12/31/1969'){
          $(td).text('');
        }
         
      }
    
    });   

});
var leavesearchcreated_at = $('#orderssearch-orderdate').val();   
if(leavesearchcreated_at =='1970-01-01'){
$('#orderssearch-orderdate').val('');
}
if(leavesearchcreated_at =='1969-12-31'){
$('#orderssearch-orderdate').val('');
}

var leavesearchcreated_at = $('#orderssearch-eventdate').val();   
if(leavesearchcreated_at =='1970-01-01'){
$('#orderssearch-eventdate').val('');
}
if(leavesearchcreated_at =='1969-12-31'){
$('#orderssearch-eventdate').val('');
}
/*
    $('td').click(function (e) {
        var id = $(this).closest('tr').data('key');
        if(e.target == this)
            location.href = '" . Url::to(['orders/update']) . "?id=' + id;
    });
*/


function trash(id){  
    var error='flase';
    if(jQuery.trim(id)==''){
        alert('Please select atleast one record!');
        error='true';
    }
    if(error=='flase'){
        if(confirm('Are you sure to Delete records?')==true){  
            $.ajax({
                                        type     :'POST',
                                        cache    :false,
                                        url: '".yii\helpers\Url::to(['orders/deletepermanent'])."',
                                        data     :{
                                            'id': id,
                                            'status':jQuery('#changestatus').val(),
                                        },
                                        success  : function(response) {                                    
                                          location.reload();                              
                                        }                            
            });
        
        }
    }
}
  function del(id){  
  
var error='flase';
if(jQuery.trim(id)==''){
    alert('Please select atleast one record!');
    error='true';
}

if(jQuery('#changestatus').val()==''){
  alert('Please select Status to move!');
    error='true';
}
//alert(error);
 if(error=='flase'){
  if(confirm('Are you sure to Move records?')==true){ 
        $.ajax({
                                        type     :'POST',
                                        cache    :false,
                                        url: '".yii\helpers\Url::to(['orders/move'])."',
                                        data     :{
                                            'id': id,
                                            'status':jQuery('#changestatus').val(),
                                        },
                                        success  : function(response) {                                    
                                          location.reload();                              
                                        }                            
                                    });

        }
    }
                         
}





            ",View::POS_END); 
 ?>
