<?php

require_once __DIR__ . '/../vendor/autoload.php';

define('APPLICATION_NAME', 'Gmail API PHP Quickstart');
define('CREDENTIALS_PATH', __DIR__ . '/test/gmail-php-quickstart.json');
define('CLIENT_SECRET_PATH', __DIR__ . '/test/client_secret.json');
define('refreshtoken', __DIR__ . '/token.txt');
//        define('STDIN',fopen("php://stdin","r"));

define('SCOPES', implode(' ', array(
		Google_Service_Gmail::GMAIL_READONLY
	)));

//echo CLIENT_SECRET_PATH;
//if (php_sapi_name() != 'cli') {
//    throw new Exception('This application must be run on the command line.');
//}

function getClient()
{
	$client = new Google_Client();
	//$client->setDefaultOption('verify', false);
	$client->setApplicationName(APPLICATION_NAME);
	$client->setScopes(SCOPES);
	$client->setAuthConfig(CLIENT_SECRET_PATH);
	$client->setAccessType('offline');
	$client->setApprovalPrompt('force');
//    $client->setRedirectUri('http://localhost/gmailAPI/index.php');

	$guzzleClient = new \GuzzleHttp\Client(array('curl' => array(CURLOPT_SSL_VERIFYPEER => false, CURLOPT_SSL_VERIFYHOST => false,),));
	$client->setHttpClient($guzzleClient);

	// Load previously authorized credentials from a file.
	$credentialsPath = expandHomeDirectory(CREDENTIALS_PATH);
	if (file_exists($credentialsPath)) {
		$accessToken = json_decode(file_get_contents($credentialsPath), true);
	} else {
		// Request authorization from the user.
		$authUrl = $client->createAuthUrl();
		printf("Open the following link in your browser:\n%s\n", $authUrl);
		print 'Enter verification code: ';
		$authCode = trim(fgets(STDIN));

		// Exchange authorization code for an access token.
		$accessToken = $client->fetchAccessTokenWithAuthCode($authCode);


		// Store the credentials to disk.
		if (!file_exists(dirname($credentialsPath))) {
			mkdir(dirname($credentialsPath), 0700, true);
		}
		file_put_contents($credentialsPath, json_encode($accessToken));
		printf("Credentials saved to %s\n", $credentialsPath);
	}

	$client->setAccessToken($accessToken);

	// Refresh the token if it's expired.
	if ($client->isAccessTokenExpired()) {
		printf("Credentials saved to \n");
		$lsPath = refreshtoken;
		$token = file_get_contents($lsPath);
		$accessToken['access_token'] = $token;
		$accessToken['created'] = strtotime("now");

		print_r($accessToken);
		printf("toeken saved to \n");
		echo json_encode($accessToken) . "\n\n\n";
		$client->fetchAccessTokenWithRefreshToken($accessToken);
		file_put_contents($credentialsPath, json_encode($accessToken));


		/*$lsPath=refreshtoken;
		 $token= file_get_contents($lsPath);
		 printf("Token - %s\n", $token);
		printf("Current token = $token \n");
	   $client->refreshToken($token);
	   $new_token = $client->getRefreshToken();
	   printf("New token after refresh= $new_token \n");
		printf("Token - %s\n", $new_token);
	   $client->fetchAccessTokenWithRefreshToken($new_token);
	   //$client->refreshToken($token);
	   printf("token fetched e \n");

	   printf("access - %s\n", $client->getAccessToken());
	   file_put_contents($credentialsPath, json_encode($client->getAccessToken()));*/

	}
	return $client;
}

/**
 * Expands the home directory alias '~' to the full path.
 * @param string $path the path to expand.
 * @return string the expanded path.
 */
function expandHomeDirectory($path)
{
	$homeDirectory = getenv('HOME');
	if (empty($homeDirectory)) {
		$homeDirectory = getenv('HOMEDRIVE') . getenv('HOMEPATH');
	}
	return str_replace('~', realpath($homeDirectory), $path);
}

function getMessage($service, $userId, $messageId)
{
	try {
		$message = $service->users_messages->get($userId, $messageId);
		return $message;
	} catch (Exception $e) {
		print 'An error occurred: ' . $e->getMessage();
	}
}

function getMessageHeader($message, $name)
{
	foreach ($message->getPayload()->getHeaders() as $header) {
		if ($header->name == $name) {
			return $header->value;
		}
	}
	return null;
}

function decodeBody($body)
{
	$rawData = $body;
	$sanitizedData = strtr($rawData, '-_', '+/');
	$decodedMessage = base64_decode($sanitizedData);
	if (!$decodedMessage) {
		$decodedMessage = FALSE;
	}
	return $decodedMessage;
}

function getFrom($from)
{
	$from = str_replace('"', '', $from);
	$from = str_replace('<', ':::', $from);
	$from = str_replace('>', '', $from);
	$fromemail = explode(":::", $from);
	$fromEm = trim($fromemail[1]);

	return $fromEm;
}

function getBody($body, $payload)
{

	$FOUND_BODY = FALSE;
	if (!$FOUND_BODY) {
		$parts = $payload->getParts();
		foreach ($parts as $part) {
			if ($part['parts'] && !$FOUND_BODY) {
				foreach ($part['parts'] as $p) {
					if ($p['parts'] && count($p['parts']) > 0) {
						foreach ($p['parts'] as $y) {
							if (($y['mimeType'] === 'text/html') && $y['body']) {
								$FOUND_BODY = decodeBody($y['body']->data);
								break;
							}
						}
					} else if (($p['mimeType'] === 'text/html') && $p['body']) {
						$FOUND_BODY = decodeBody($p['body']->data);
						break;
					}
				}
			}
			if ($FOUND_BODY) {
				break;
			}
		}
	}
	// let's save all the images linked to the mail's body:
	if ($FOUND_BODY && count($parts) > 1) {
		$images_linked = array();
		foreach ($parts as $part) {
			if ($part['filename']) {
				array_push($images_linked, $part);
			} else {
				if ($part['parts']) {
					foreach ($part['parts'] as $p) {
						if ($p['parts'] && count($p['parts']) > 0) {
							foreach ($p['parts'] as $y) {
								if (($y['mimeType'] === 'text/html') && $y['body']) {
									array_push($images_linked, $y);
								}
							}
						} else if (($p['mimeType'] !== 'text/html') && $p['body']) {
							array_push($images_linked, $p);
						}
					}
				}
			}
		}
		// special case for the wdcid...
		preg_match_all('/wdcid(.*)"/Uims', $FOUND_BODY, $wdmatches);
		if (count($wdmatches)) {
			$z = 0;
			foreach ($wdmatches[0] as $match) {
				$z++;
				if ($z > 9) {
					$FOUND_BODY = str_replace($match, 'image0' . $z . '@', $FOUND_BODY);
				} else {
					$FOUND_BODY = str_replace($match, 'image00' . $z . '@', $FOUND_BODY);
				}
			}
		}
		preg_match_all('/src="cid:(.*)"/Uims', $FOUND_BODY, $matches);
		if (count($matches)) {
			$search = array();
			$replace = array();
			// let's trasnform the CIDs as base64 attachements
			foreach ($matches[1] as $match) {
				foreach ($images_linked as $img_linked) {
					foreach ($img_linked['headers'] as $img_lnk) {
						if ($img_lnk['name'] === 'Content-ID' || $img_lnk['name'] === 'Content-Id' || $img_lnk['name'] === 'X-Attachment-Id') {
							if ($match === str_replace('>', '', str_replace('<', '', $img_lnk->value)) || explode("@", $match)[0] === explode(".", $img_linked->filename)[0] || explode("@", $match)[0] === $img_linked->filename) {
								$search = "src=\"cid:$match\"";
								$mimetype = $img_linked->mimeType;
								$attachment = $gmail->users_messages_attachments->get('me', $mlist->id, $img_linked['body']->attachmentId);
								$data64 = strtr($attachment->getData(), array('-' => '+', '_' => '/'));
								$replace = "src=\"data:" . $mimetype . ";base64," . $data64 . "\"";
								$FOUND_BODY = str_replace($search, $replace, $FOUND_BODY);
							}
						}
					}
				}
			}
		}
	}
	if (!$FOUND_BODY) {
		$parts = $payload->getParts();
		foreach ($parts as $part) {
			if ($part['body'] && $part['mimeType'] === 'text/html') {
				$FOUND_BODY = decodeBody($part['body']->data);
				break;
			}
		}
	}
	if (!$FOUND_BODY) {
		$FOUND_BODY = decodeBody($body['data']);
	}
	if (!$FOUND_BODY) {
		$parts = $payload->getParts();
		foreach ($parts as $part) {
			if ($part['body']) {
				$FOUND_BODY = decodeBody($part['body']->data);
				break;
			}
		}
	}
	if (!$FOUND_BODY) {
		$FOUND_BODY = "";
	}

	$final_str = "";

	if (!empty($FOUND_BODY)) {
		$dom = new DOMDocument;
		$dom->loadHTML($FOUND_BODY);
		$xpath = new DomXPath($dom);
		foreach ($dom->getElementsByTagName('p') as $ptag) {
			$mystring = $ptag->textContent;
			$final_str .= $mystring;
			$final_str .= "<br/>";
		}
	}

	return $final_str;
}

// Get the API client and construct the service object.
$client = getClient();
$service = new Google_Service_Gmail($client);

// Print the labels in the user's account.
$user = 'me';
//$before = date('Y/m/d', strtotime(' +25 day'));
//$after = date('Y/m/d', strtotime(' -25 day'));

die('Done');

$messagesResponse = $service->users_messages->listUsersMessages($user, ['labelIds' => 'INBOX']);
//$messagesResponse=$service->users_messages->listUsersMessages($user,['labelIds'=>'INBOX']);    
// printf("already exist- %s\n","gameeee-final"); 
// die("");
if ($messagesResponse->getMessages()) {
	$messages = $messagesResponse->getMessages();
}

if (!empty($messages)) {
	$messages = array_reverse($messages);
	//print_r($messages);
	$optParamsGet2['format'] = 'full';
	foreach ($messages as $singlemessahe) {

		$m_id = $singlemessahe->id;
		$message = getMessage($service, $user, $singlemessahe->id, $optParamsGet2);
		$from = getMessageHeader($message, 'From');
		$to_text = getMessageHeader($message, 'To');

		$from = getFrom($from);

		$payload = $message->getPayload();
		$body = $payload->getBody();

		$body = getBody($body, $payload);

		echo("\n mid=" . $m_id);
		echo("\n From=" . $from);
		echo("\n To=" . $to_text);
		echo("\n Body=" . $body);
		echo "\n";
	}
	echo "\n";
}


//        $results = $service->users_labels->listUsersLabels($user);
//
//        if (count($results->getLabels()) == 0) {
//            print "No labels found.\n";
//        } else {
//            print "Labels:\n";
//            foreach ($results->getLabels() as $label) {
//                printf("- %s\n", $label->getName());
//            }
//        }
?>
