<?php
namespace backend\controllers;
use Yii;
use backend\models\Orders;
use backend\models\OrdersSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\web\Session;
class OrderreportsController extends Controller
{
    public function behaviors()
    {
        return [
               'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['test'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['report','csv','event_date_search','event_date_search_export'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }
    

     public function actionCsv($from,$to){
     ini_set('memory_limit','-1');
     
        
        
           $models = Orders::find()->where("OrderDate IN (SELECT OrderDate FROM `orders` where OrderDate >= '$from' and OrderDate <= '$to')")->all();  
        
          // $models = Orders::find()->where(['Status' => $search])->orderBy(['OrderDate' => SORT_DESC])->all();  
           if(!empty($models)) {
               
            $fileName = "SGordersreport-".time().'.csv';
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header('Content-Description: File Transfer');
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename={$fileName}");
            header("Expires: 0");
            header("Pragma: public");
            $fh = @fopen( 'php://output', 'w' ); 
               
               $headerDisplayed = false;    
               foreach($models as $model){
                   $single=array();
                   $single['Order Date']=$model->OrderDate;
                   $single['Order#']=$model->OrderMainId;
                   $single['Quantity']=$model->Quantity;
                   $single['Event']=$model->Event;
                   $single['venue']=$model->Venue;
                   $single['Section']=$model->Section;
                   $single['Row']=$model->Row;
                   $single['Event Data']=$model->EventDate;
                   if(!empty($model->Cost)) {
                       $single['Cost']='$'.$model->Cost;
                   }else{
                   $single['Cost']=$model->Cost;
                   }
                   if(Yii::$app->user->identity->Role!='user') {
                    $single['Sale Price']='$'.$model->SalePrice;
                    if(!empty($model->Profit)) {
                     $single['Profit']='$'.$model->Profit;
                    }else{
                    $single['Profit']=$model->Profit;
                    }
                   }
                   $single['Source']=$model->Source;
                   if(!empty($model->CreditCard)) {
                       if($model->CreditCard=="OTHER") {
                        $single['Credit Card']=$model->Othertype;    
                       }else{
                        $single['Credit Card']=$model->CreditCard; 
                       }
                   }else{
                   $single['Credit Card']=$model->CreditCard;                 
                   }
                   $single['Link']=$model->Link;
                   $single['DeliveryMethod']=$model->DeliveryMethod;
                    $single['Notes']=$model->Notes;
                   $single['Edited']=$model->UpdateBy;
                   $single['Purchased']=$model->Purchased;
                   $single['Paid']=$model->Paid;
                   $single['Status']=$model->Status;
                   $data=$single;               
                    if ( !$headerDisplayed ) {                   
                        fputcsv($fh, array_keys($data));
                        $headerDisplayed = true;
                    }
                    fputcsv($fh, $data);                  
               }
                fclose($fh);           
                exit;
           }
        
    }
    public function beforeAction($action)
	{
		if (!parent::beforeAction($action)) {
			return false;
		}
		// Check only when the user is logged in
		if (!Yii::$app->user->isGuest) {

			$time = \Yii::$app->session->get('userSessionTimeout');

			if ($time < time()) {
				Yii::$app->user->logout();
			} else {
				\Yii::$app->session->set('userSessionTimeout', time() + Yii::$app->params['sessionTimeoutSeconds']);
				return true;
			}
		} else {
			return true;
		}
	}
	  public function actionReport(){ 
      ini_set('memory_limit','-1');
       $mysourceorder= $mysource_profit=$mysource_sale=$mysource_cost=array();
         $final_array=array();
         if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }
		 $orders = array();
		 $orders = Orders::find()->select(['OrderDate', 'OrderDate' ,'OrderMainId','Quantity','Event','Venue','Row','Section','EventDate','Cost','SalePrice','Profit','Source','Link','DeliveryMethod','Notes','UpdateBy','Purchased','Paid','Status'])->where("OrderDate IN (SELECT OrderDate FROM `orders` where OrderDate >= '$from' and OrderDate <= '$to')")->asArray()->all();
         return $this->render('report', [
            'from' => $from, 
            'to' => $to, 
            'finaldata' => $orders, 
             
        ]);
         
     }

    public function actionEvent_date_search()
	{ 
        \Yii::$app->session->set('user.backprocress','event_date_search');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->event_date_search(Yii::$app->request->queryParams);
		\Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-report', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	
	 public function actionEvent_date_search_export(){
		ini_set('memory_limit','-1');
		 if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){ 
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }

        if(!empty($from) || !empty($to)) {
            $models = Orders::find()->where("EventDate IN (SELECT EventDate FROM `orders` where EventDate >= '$from' and EventDate <= '$to')")->orderBy(['Event'=>SORT_ASC,'Venue' => SORT_ASC,'Purchased'=>SORT_ASC])->all();
        }else{
            $models = Orders::find()->where('Status != :status', [':status' => 'DELETED'])->orderBy(['Event'=>SORT_ASC,'Venue' => SORT_ASC,'Purchased'=>SORT_ASC])->all();  
        }
          // $models = Orders::find()->where(['Status' => $search])->orderBy(['OrderDate' => SORT_DESC])->all();  
           if(!empty($models)) {

            $fileName = "EventDateSearchOrders-".time().'.csv';
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header('Content-Description: File Transfer');
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename={$fileName}");
            header("Expires: 0");
            header("Pragma: public");
            $fh = @fopen( 'php://output', 'w' ); 
               
               $headerDisplayed = false;    
               foreach($models as $model){
                   $single=array();
                   $single['Order Date']=$model->OrderDate;
                   $single['Order#']=$model->OrderMainId;
                   $single['Quantity']=$model->Quantity;
                   $single['Event']=$model->Event;
                   $single['venue']=$model->Venue;
                   $single['Section']=$model->Section;
                   $single['Row']=$model->Row;
                   $single['Event Data']=$model->EventDate;
                   if(!empty($model->Cost)) {
                       $single['Cost']='$'.$model->Cost;
                   }else{
                   $single['Cost']=$model->Cost;
                   }
                   if(Yii::$app->user->identity->Role!='user') {
                    $single['Sale Price']='$'.$model->SalePrice;
                    if(!empty($model->Profit)) {
                     $single['Profit']='$'.$model->Profit;
                    }else{
                    $single['Profit']=$model->Profit;
                    }
                   }
                   $single['Source']=$model->Source;
                   if(!empty($model->CreditCard)) {
                       if($model->CreditCard=="OTHER") {
                        $single['Credit Card']=$model->Othertype;    
                       }else{
                        $single['Credit Card']=$model->CreditCard; 
                       }
                   }else{
                   $single['Credit Card']=$model->CreditCard;                 
                   }
				   
				   $single['Link']=$model->Link;
                   $single['DeliveryMethod']=$model->DeliveryMethod;
                   $single['Notes']=$model->Notes;
                   $single['Edited']=$model->UpdateBy;
                   $single['Purchased']=$model->Purchased;
                   $single['Paid']=$model->Paid;
                   $single['Status']=$model->Status;
                   $single['Covid']=$model->Covid;
				   
                   $data=$single;               
                    if ( !$headerDisplayed ) {                   
                        fputcsv($fh, array_keys($data));
                        $headerDisplayed = true;
                    }
                    fputcsv($fh, $data);                  
               }
                fclose($fh);           
                exit;
           }
        
    }
	
	 
}
?>