<?php

namespace backend\controllers;
use backend\PdfToTextmaster\PdfToText;
use backend\PHPExcel\Classes\PHPExcel\IOFactory; 
use Yii;
use backend\models\Orders;
use backend\models\UploadCsv;
use backend\models\UploadPdf;
use backend\models\UploadXlsx;
use backend\models\OrdersDemo;
use backend\models\OrdersSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\web\Session;
use yii\web\UploadedFile;
use yii\db\Expression;

/**
 * OrdersController implements the CRUD actions for Orders model.
 */
class OrdersController extends Controller
{
    public function behaviors()
    {
        return [
               'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['test'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['changepriority','deletepermanent','links','trash','cancelled','move','csv','update', 'index','delete','view','create','buy','buyhanna','buydeepak','waiting','payment','completed','delayed','toship','presale','soldout','problem','bought','postponed','working','dontbuyyet','uploadcsv','uploadpdf','uploadtnpdf','uploadtnpricepdf','uploadticketpdf','uploadtmcsv','uploadtncsv' , 'uploadmrccsv', 'uploadcreditmemoxlsx','uploadstubhubxlsx','uploadseatgeekxlsx','uploadpaidxlsx','uploadpdfv2','movetocompleted','uploadpdfv3','totransfer'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }
 public function beforeAction($action)
    {
    //var_dump('Yii::$app->user->isGuest');
        if (!parent::beforeAction($action)) {
            return false;
        }
        // Check only when the user is logged in
        if ( !Yii::$app->user->isGuest)  { 
            
            $time=\Yii::$app->session->get('userSessionTimeout');
            
            if ($time < time()) {
                //Yii::$app->user->logout();
                \Yii::$app->session->set('userSessionTimeout',time() + Yii::$app->params['sessionTimeoutSeconds']);      
                return true; 
            } else {
                \Yii::$app->session->set('userSessionTimeout',time() + Yii::$app->params['sessionTimeoutSeconds']);      
                return true; 
            }
        } else {
            return true;
        }
    }
    /**
     * Lists all Orders models.
     * @return mixed
     */
    public function actionCsv($status){
		ini_set('memory_limit','-1');
      $action=$status;
        if($action=="buy"){
            $search='TO BUY';          
        }elseif($action=="waiting"){
            $search='WAITING PAYMENT';      
        }elseif($action=="payment"){
            $search='PAYMENT RECEIVED';      
        }elseif($action=="completed"){
            $search='COMPLETED';      
        }elseif($action=="delayed"){
            $search='DELAYED';       
        }elseif($action=="toship"){
            $search='TO SHIP';        
        }elseif($action=="presale"){
            $search='PRESALE';       
        }elseif($action=="soldout"){
            $search='SOLD OUT';       
        }elseif($action=="problem"){
            $search='PROBLEM';       
        }elseif($action=="bought"){
            $search='BOUGHT';      
        }elseif($action=="cancelled"){
            $search='CANCELLED';      
        }elseif($action=="links"){
            $search='LINKS TO ADD';      
        }elseif($action=="trash"){
            $search='TRASH';      
        }elseif($action=="index"){
            $search='all';      
        }elseif($action=="dontbuyyet"){
            $search='dontbuyyet';      
        }elseif($action=="totransfer"){
            $search='totransfer';      
        }elseif($action=="working"){
            $search='working';      
        }else{
            $this->redirect(["orders/"]);
            exit;
        }
        
        if($search!="all") {
           $models = Orders::find()->where(['Status' => $search])->orderBy(['EventDate' => SORT_ASC])->all();  
        }else{
            $models = Orders::find()->where('Status != :status', [':status' => 'DELETED'])->orderBy(['EventDate' => SORT_ASC])->all();  
        }
          // $models = Orders::find()->where(['Status' => $search])->orderBy(['OrderDate' => SORT_DESC])->all();  
           if(!empty($models)) {
               
            $fileName = "Orders-".time().'.csv';
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header('Content-Description: File Transfer');
            header("Content-type: text/csv");
            header("Content-Disposition: attachment; filename={$fileName}");
            header("Expires: 0");
            header("Pragma: public");
            $fh = @fopen( 'php://output', 'w' ); 
               
               $headerDisplayed = false;    
               foreach($models as $model){
                   $single=array();
                   $single['Order Date']=$model->OrderDate;
                   $single['Order#']=$model->OrderMainId;
                   $single['Quantity']=$model->Quantity;
                   $single['Event']=$model->Event;
                   $single['venue']=$model->Venue;
                   $single['Section']=$model->Section;
                   $single['Row']=$model->Row;
                   $single['Event Data']=$model->EventDate;
                   if(!empty($model->Cost)) {
                       $single['Cost']='$'.$model->Cost;
                   }else{
                   $single['Cost']=$model->Cost;
                   }
                   if(Yii::$app->user->identity->Role!='user') {
                    $single['Sale Price']='$'.$model->SalePrice;
                    if(!empty($model->Profit)) {
                     $single['Profit']='$'.$model->Profit;
                    }else{
                    $single['Profit']=$model->Profit;
                    }
                   }
                   $single['Source']=$model->Source;
                   if(!empty($model->CreditCard)) {
                       if($model->CreditCard=="OTHER") {
                        $single['Credit Card']=$model->Othertype;    
                       }else{
                        $single['Credit Card']=$model->CreditCard; 
                       }
                   }else{
                   $single['Credit Card']=$model->CreditCard;                 
                   }
                   $single['Link']=$model->Link;
                   $single['Notes']=$model->Notes;
                   $single['Status']=$model->Status;
                   $data=$single;               
                    if ( !$headerDisplayed ) {                   
                        fputcsv($fh, array_keys($data));
                        $headerDisplayed = true;
                    }
                    fputcsv($fh, $data);                  
               }
                fclose($fh);           
                exit;
           }
        
    }
    public function actionDeletepermanent(){
        $status="DELETED";
        foreach($_REQUEST['id'] as $id){            
                $model = Orders::find()
                ->where(['OrderId' => $id])
                ->one(); 
                $model->Status=$status;
                $model->Updated_at=date('Y-m-d H:i:s');
                $model->save(false);                
        }
        echo "succes";
        die;       
    }
    
    public function actionChangepriority(){
        
        $id=$_REQUEST['id'];
                $model = Orders::find()
                ->where(['OrderId' => $id])
                ->one(); 
                $priority=$model->Priority;
                $new_priority=$priority===1?0:1;
                $model->Priority=$new_priority;
                $model->Updated_at=date('Y-m-d H:i:s');
                $model->save(false);                
        
        echo $new_priority;
        die;       
    }
    
    public function actionMove(){
        $status=trim($_REQUEST['status']);
        foreach($_REQUEST['id'] as $id){            
                $model = Orders::find()
                ->where(['OrderId' => $id])
                ->one(); 
				
				if($status == 'LINKS TO ADD' && $model->Source == 'Ticket Evolution'){
					$model->Paid=date('Y-m-d');
				}	
				if($status == 'WAITING PAYMENT'){
					$model->Purchased=date('Y-m-d');
				}	
				
                $model->Status=$status;
                $model->Updated_at=date('Y-m-d H:i:s');
                $model->save(false);                
        }
        echo "succes";
        die;       
    }
	
	 public function actionMovetocompleted(){
        $status=trim($_REQUEST['status']);
		$models = Orders::find()->where(['Status' =>  'PAYMENT RECEIVED'])->all();  
		 if(!empty($models)){
			foreach($models as $model){          
			   $order_data = Orders::find()
                ->where(['OrderId' => $model->OrderId])
                ->one(); 

                $order_data->Status=$status;
                $order_data->Updated_at=date('Y-m-d H:i:s');
                $order_data->save(false); 
			 }
		 }	
		 echo "succes";
        die;   	
    }
	
    public function actionTrash()
    {
    \Yii::$app->session->set('user.backprocress','trash');
  
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchTrash(Yii::$app->request->queryParams);
    \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    public function actionLinks()
    {
    \Yii::$app->session->set('user.backprocress','links');
  
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchLinks(Yii::$app->request->queryParams);
    \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionIndex()
    {
        \Yii::$app->session->set('user.backprocress','index');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
public function actionCancelled()
    {
    \Yii::$app->session->set('user.backprocress','cancelled');
  
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchcancelled(Yii::$app->request->queryParams);
    \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    public function actionBuy()
    {//JELENA
        \Yii::$app->session->set('user.backprocress','buy');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchbuy(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
           
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    public function actionBuyhanna()
    {
        \Yii::$app->session->set('user.backprocress','buyhanna');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchbuy(Yii::$app->request->queryParams,'TO BUY HANNA');
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
                   return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	public function actionBuydeepak()
    {
        \Yii::$app->session->set('user.backprocress','buydeepak');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchbuy(Yii::$app->request->queryParams,'TO BUY DEEPAK');
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
           
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    public function actionTotransfer()
    {
        \Yii::$app->session->set('user.backprocress','totransfer');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchbuy(Yii::$app->request->queryParams,'TO TRANSFER');
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
  
    public function actionWaiting()
    {
         \Yii::$app->session->set('user.backprocress','waiting');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchwaiting(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionPayment()
    {
           \Yii::$app->session->set('user.backprocress','payment');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchpayment(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionCompleted()
    {
          \Yii::$app->session->set('user.backprocress','completed');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchcompleted(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    public function actionDelayed()
    {
        \Yii::$app->session->set('user.backprocress','delayed');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchdelayed(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionToship()
    {
        \Yii::$app->session->set('user.backprocress','toship');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchtoship(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionPresale()
    {
         \Yii::$app->session->set('user.backprocress','presale');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchpresale(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionSoldout()
    {
         \Yii::$app->session->set('user.backprocress','soldout');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchsoldout(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionProblem()
    {
          \Yii::$app->session->set('user.backprocress','problem');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchproblem(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
      public function actionBought()
    {
           \Yii::$app->session->set('user.backprocress','bought');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchbought(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	public function actionPostponed()
    {
        \Yii::$app->session->set('user.backprocress','postponed');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchpostponed(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	public function actionWorking()
    {
        \Yii::$app->session->set('user.backprocress','working');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchworking(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	public function actionDontbuyyet()
    {
        \Yii::$app->session->set('user.backprocress','dontbuyyet');
        $searchModel = new OrdersSearch();
        $dataProvider = $searchModel->searchdontbuyyet(Yii::$app->request->queryParams);
        \Yii::$app->session->set('user.queryparam',Yii::$app->request->queryParams);
        return $this->render('index-chnaged', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	
    /**
     * Displays a single Orders model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Orders model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Orders();
		$model->scenario = 'create';
		//$model->OrderMainId = trim($_POST['Orders']['OrderMainId']);
        if ($model->load(Yii::$app->request->post())) {
            if($_POST['Orders']['OrderMainId']==''){
                $model->OrderMainId = NULL;
            }else{
                $model->OrderMainId = trim($_POST['Orders']['OrderMainId']);
            }
           
			   if($model->save()) {
               Yii::$app->session->setFlash('success','Order Successfully Added');
               $back=\Yii::$app->session->get('user.backprocress');
			    if ( strstr( $back, 'event_date_searchevent_date_search' ) ) {
				 $back =  'orderreports/'.$back;
				} 
                 if(!empty($back)) {
                       return $this->redirect([$back]);
                 }else{
                      return $this->redirect(['buy']);
                 }
			   } else {
					return $this->render('create', [
						'model' => $model,
					]);
               }
          
           // return $this->redirect(['view', 'id' => $model->OrderId]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Orders model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        $model->scenario = 'update';
        if ($model->load(Yii::$app->request->post())) {
            $FirstName=Yii::$app->user->identity->FirstName;
            $LastName=Yii::$app->user->identity->LastName;
            $model->UpdateBy=$FirstName." ".$LastName;
            $model->Updated_at=date('Y-m-d H:i:s');
            $status = $_POST['Orders']['Status'];
            $source = $_POST['Orders']['Source'];

            //if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK') and Paid IS NULL")->one()) !== null){
                
        //} 
            

			/* if($status == 'PAYMENT RECEIVED'){
					$model->Paid=date('Y-m-d');
				} */	
				
			if(empty($_POST['Orders']['Paid'])){
				$model->Paid = NULL;
			} else {
				$model->Paid = $_POST['Orders']['Paid'];
			}
			if($status == 'WAITING PAYMENT'){
					$model->Purchased=date('Y-m-d');
			}		
            if(!empty($model->Cost)){
                $model->Profit=$model->SalePrice-$model->Cost;
            } 
            
            if($_POST['Orders']['OrderMainId']==''){
                $model->OrderMainId = NULL;
            }else{
                $model->OrderMainId = trim($_POST['Orders']['OrderMainId']);
            }
			
            $res=$model->save();      
            //var_dump($res);  
           // var_dump($model->getErrors());
            if($res) {
                 Yii::$app->session->setFlash('success','Order Successfully Updated');
                 $back=\Yii::$app->session->get('user.backprocress');
				if ( strstr( $back, 'event_date_search' ) ) {
				 $back =  'orderreports/'.$back;
				} 
                 $queryparam=\Yii::$app->session->get('user.queryparam');             
                 if(!empty($back)) {
                     if(!empty($queryparam['OrdersSearch'])) {
                          if(Yii::$app->user->identity->Role!='user') {                        
                          return $this->redirect([$back,"OrdersSearch[OrderDate]"=>$queryparam['OrdersSearch']['OrderDate'],
                                "OrdersSearch[OrderMainId]"=>$queryparam['OrdersSearch']['OrderMainId'],
                                "OrdersSearch[Quantity]"=>$queryparam['OrdersSearch']['Quantity'],
                                "OrdersSearch[Event]"=>$queryparam['OrdersSearch']['Event'],
                                "OrdersSearch[Venue]"=>$queryparam['OrdersSearch']['Venue'],
                                "OrdersSearch[Section]"=>$queryparam['OrdersSearch']['Section'],
                                "OrdersSearch[Row]"=>$queryparam['OrdersSearch']['Row'],
                                "OrdersSearch[EventDate]"=>$queryparam['OrdersSearch']['EventDate'],
                                "OrdersSearch[Cost]"=>$queryparam['OrdersSearch']['Cost'],
                                "OrdersSearch[SalePrice]"=>$queryparam['OrdersSearch']['SalePrice'],
                                "OrdersSearch[Profit]"=>$queryparam['OrdersSearch']['Profit'],
                                "OrdersSearch[Source]"=>$queryparam['OrdersSearch']['Source'], 
                                "OrdersSearch[Link]"=>$queryparam['OrdersSearch']['Link'], 
                                "OrdersSearch[Notes]"=>$queryparam['OrdersSearch']['Notes'], 
                                "OrdersSearch[Status]"=>$queryparam['OrdersSearch']['Status']]);
                          }else{
                            
                              return $this->redirect([$back,"OrdersSearch[OrderDate]"=>$queryparam['OrdersSearch']['OrderDate'],
                                "OrdersSearch[OrderMainId]"=>$queryparam['OrdersSearch']['OrderMainId'],
                                "OrdersSearch[Quantity]"=>$queryparam['OrdersSearch']['Quantity'],
                                "OrdersSearch[Event]"=>$queryparam['OrdersSearch']['Event'],
                                "OrdersSearch[Venue]"=>$queryparam['OrdersSearch']['Venue'],
                                "OrdersSearch[Section]"=>$queryparam['OrdersSearch']['Section'],
                                "OrdersSearch[Row]"=>$queryparam['OrdersSearch']['Row'],
                                "OrdersSearch[EventDate]"=>$queryparam['OrdersSearch']['EventDate'],
                                "OrdersSearch[Cost]"=>$queryparam['OrdersSearch']['Cost'],
                                "OrdersSearch[Source]"=>$queryparam['OrdersSearch']['Source'], 
                                  "OrdersSearch[Link]"=>$queryparam['OrdersSearch']['Link'], 
                                "OrdersSearch[Notes]"=>$queryparam['OrdersSearch']['Notes'],
                                "OrdersSearch[Status]"=>$queryparam['OrdersSearch']['Status']]);
                          }
                         
                      //                             
                   
                     }else{
                         return $this->redirect([$back]);
                     }
                 }else{
                      return $this->redirect(['buy']);
                 }
                // return $this->redirect(['view', 'id' => $model->OrderId]);
            }else{
                return $this->render('update', [
                'model' => $model,
                ]);
            }           
        } else {
            $ref_url=Yii::$app->request->referrer;//$this->redirect(Yii::$app->request->referrer);
             //var_dump($ref_url);
            if(isset($ref_url)){
                $splt=  explode("?", $ref_url);
                if(isset($splt[1])){
                    $splt_slash=  explode("/", $ref_url);
                    $count=count($splt_slash);
                    $start=$splt_slash[$count-1];
                   // var_dump($start);
                    //$qstr=$splt[1];
                    if($start){
                     \Yii::$app->session->set('user.backprocress',$start);
                    }
                }
                //$url_str=
            }
           
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Orders model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $model=$this->findModel($id);
        if(!empty($model)) {
             $back=\Yii::$app->session->get('user.backprocress');
			 if ( strstr( $back, 'event_date_search' ) ) {
				 $back =  'orderreports/'.$back;
				} 
             if($model->Status=="TRASH") {
                 $model->Status="DELETED";
             }else{
                 $model->Status="TRASH";
             }
       // $model->Status="DELETED";
            if($model->save(false)){
                Yii::$app->session->setFlash('success','Order Successfully Deleted');
                 $back=\Yii::$app->session->get('user.backprocress');
				 if ( strstr( $back, 'event_date_search' ) ) {
				 $back =  'orderreports/'.$back;
				} 
                 $queryparam=\Yii::$app->session->get('user.queryparam');             
                 if(!empty($back)) {
                     if(!empty($queryparam['OrdersSearch'])) {
                          if(Yii::$app->user->identity->Role!='user') {                        
                          return $this->redirect([$back,"OrdersSearch[OrderDate]"=>$queryparam['OrdersSearch']['OrderDate'],
                                "OrdersSearch[OrderMainId]"=>$queryparam['OrdersSearch']['OrderMainId'],
                                "OrdersSearch[Quantity]"=>$queryparam['OrdersSearch']['Quantity'],
                                "OrdersSearch[Event]"=>$queryparam['OrdersSearch']['Event'],
                                "OrdersSearch[Venue]"=>$queryparam['OrdersSearch']['Venue'],
                                "OrdersSearch[Section]"=>$queryparam['OrdersSearch']['Section'],
                                "OrdersSearch[Row]"=>$queryparam['OrdersSearch']['Row'],
                                "OrdersSearch[EventDate]"=>$queryparam['OrdersSearch']['EventDate'],
                                "OrdersSearch[Cost]"=>$queryparam['OrdersSearch']['Cost'],
                                "OrdersSearch[SalePrice]"=>$queryparam['OrdersSearch']['SalePrice'],
                                "OrdersSearch[Profit]"=>$queryparam['OrdersSearch']['Profit'],
                                "OrdersSearch[Source]"=>$queryparam['OrdersSearch']['Source'], 
                                "OrdersSearch[CreditCard]"=>$queryparam['OrdersSearch']['CreditCard'],
                              "OrdersSearch[Link]"=>$queryparam['OrdersSearch']['Link'], 
                                "OrdersSearch[Notes]"=>$queryparam['OrdersSearch']['Notes'],
                                "OrdersSearch[Status]"=>$queryparam['OrdersSearch']['Status']]);
                          }else{
                            
                              return $this->redirect([$back,"OrdersSearch[OrderDate]"=>$queryparam['OrdersSearch']['OrderDate'],
                                "OrdersSearch[OrderMainId]"=>$queryparam['OrdersSearch']['OrderMainId'],
                                "OrdersSearch[Quantity]"=>$queryparam['OrdersSearch']['Quantity'],
                                "OrdersSearch[Event]"=>$queryparam['OrdersSearch']['Event'],
                                "OrdersSearch[Venue]"=>$queryparam['OrdersSearch']['Venue'],
                                "OrdersSearch[Section]"=>$queryparam['OrdersSearch']['Section'],
                                "OrdersSearch[Row]"=>$queryparam['OrdersSearch']['Row'],
                                "OrdersSearch[EventDate]"=>$queryparam['OrdersSearch']['EventDate'],
                                "OrdersSearch[Cost]"=>$queryparam['OrdersSearch']['Cost'],
                                "OrdersSearch[Source]"=>$queryparam['OrdersSearch']['Source'], 
                                "OrdersSearch[CreditCard]"=>$queryparam['OrdersSearch']['CreditCard'], 
                                  "OrdersSearch[Link]"=>$queryparam['OrdersSearch']['Link'], 
                                "OrdersSearch[Notes]"=>$queryparam['OrdersSearch']['Notes'],
                                "OrdersSearch[Status]"=>$queryparam['OrdersSearch']['Status']]);
                          }
                         
                      //                             
                   
                     }else{
                         return $this->redirect([$back]);
                     }
                 }else{
                      return $this->redirect(['buy']);
                 }
            }else{
               return $this->redirect(['buy']); 
            }
         //return $this->redirect(['index']);}
        }else{
             return $this->redirect(['buy']);
        }
    }

    /**
     * Finds the Orders model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Orders the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Orders::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
	public function actionUploadcreditmemoxlsx(){

		$model = new UploadXlsx();
        if (Yii::$app->request->isPost) {
            $model->xlsxFile = UploadedFile::getInstance($model, 'xlsxFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymentcreditmemo_'.$rand_string.'.'.$model->xlsxFile->extension;
				$model->xlsxFile->saveAs('uploads/payment-xlsx/' .$file_name);
				$base_path = \Yii::$app->basePath.'/uploads/payment-xlsx/'.$file_name;
				$objPHPExcel = IOFactory::load($base_path);
				$sheet_arr = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
				
				unset($sheet_arr[1],$sheet_arr[2],$sheet_arr[3],$sheet_arr[4]);
				foreach($sheet_arr as $key=>$sheet_val) {
					if(!empty($sheet_val)) {	
						$order_no = $sheet_val['F'];
						if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK') and Paid IS NULL")->one()) !== null){
								$orderdata->Paid = date('Y-m-d');
								$orderdata->update();
						} 
				
					} 
						
				}	
				
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Credit Memo Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadcreditmemoxlsx']);
			}
            
        }

        return $this->render('uploadcreditmemoxlsx', ['model' => $model]);
	}
	
	
	 public function actionUploadseatgeekxlsx(){
		$model = new UploadXlsx();
        if (Yii::$app->request->isPost) {
            $model->xlsxFile = UploadedFile::getInstance($model, 'xlsxFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymentseatgeek_'.$rand_string.'.'.$model->xlsxFile->extension;
				$model->xlsxFile->saveAs('uploads/payment-xlsx/' .$file_name);
				$base_path = \Yii::$app->basePath.'/uploads/payment-xlsx/'.$file_name;
				$objPHPExcel = IOFactory::load($base_path);
                $hide_A=$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setVisible(false);
                $hide_B=$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setVisible(false);
				$sheet_arr = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);



				
				unset($sheet_arr[1],$sheet_arr[2],$sheet_arr[3],$sheet_arr[4]);
               
				foreach($sheet_arr as $key=>$sheet_val) 
                { 
    				$order_no = trim($sheet_val['D']);
                    //$order_amount = trim(str_replace('$','',$sheet_val['H']));
                    $order_amount =trim(preg_replace('~[$()]~', '', $sheet_val['H']));
                    if($order_no!=''){
                    $to = 'kris@kriskellymusic.com'; 
                    $order_status = "";
                    if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null)
                    {
                        //echo"WAITING PAYMENT";
                        $order_status = $orderdata->Status;
                        $orderdata->Paid = date('Y-m-d');
                        $db_amt  =  $orderdata->SalePrice ;
                        if ($orderdata->update() !== false) 
                        {
                            
                            if($order_amount != $db_amt){
                                //echo"amount mismatch";
                                //below line commneted for some time.  
                                ///$this->order_mismatch_email($order_no,$order_amount,$db_amt,$to);
                            }   
                        }
                        else{
                        }                        
                    } 
                    else 
                    {
                        if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) 
                        {  
                            //echo "completed";
                        }
                        else 
                        {
                           //echo"Not found";
                        $this->order_not_found_email($order_no,$order_amount,$to);
                        }
                    }
                    
                  
	               }
				}

				unlink($base_path);

                //die('ggcbfg');

                
                
				\Yii::$app->getSession()->setFlash('success', 'Orders seat geek Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadseatgeekxlsx']);

			}
            
        }

        return $this->render('uploadseatgeekxlsx', ['model' => $model]);
	} 
	
	
	public function actionUploadpaidxlsx(){

		$model = new UploadXlsx();
        if (Yii::$app->request->isPost) {
            $model->xlsxFile = UploadedFile::getInstance($model, 'xlsxFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymentpaidxlsx_'.$rand_string.'.'.$model->xlsxFile->extension;
				$model->xlsxFile->saveAs('uploads/payment-xlsx/' .$file_name);
				$base_path = \Yii::$app->basePath.'/uploads/payment-xlsx/'.$file_name;
				$objPHPExcel = IOFactory::load($base_path);
				$sheet_arr = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
			
				foreach($sheet_arr as $key=>$sheet_val) {
					if(!empty($sheet_val)) {	
						 $order_no = $sheet_val['A'];
						 if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and Paid IS NULL")->one()) !== null){
								$orderdata->Paid = date('Y-m-d');
								$orderdata->update();
						}	
					
					} 	
				}
				
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders paid xlsx has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadpaidxlsx']);
			}
            
        }

        return $this->render('uploadpaidxlsx', ['model' => $model]);
	}
	
	
	
	
	
	public function actionUploadpdf(){
	  $model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
				$model->pdfFile->saveAs('uploads/payment-csv/' .$file_name);
				$filename = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				//include ( \Yii::$app->basePath.'/PdfToText-master/PdfToText.phpclass' ) ;
				$pdf    =  new PdfToText ( $filename ) ;
				 $pdf_content = $pdf -> Text ;         // 
				//die;
				//$pdf_arr = explode("Direct To You Tickets, Inc.",$pdf_content);
				$pdf_arr = explode("Direct To You Tickets",$pdf_content);

				function trimArray(&$value) 
				{ 
					$value = trim($value); 
				}

				array_walk($pdf_arr, 'trimArray');

				 
				//die; 
				 unset($pdf_arr[0]); 
				 unset($pdf_arr[1]); 
				 /*   echo '<pre>';
				print_r($pdf_arr); 
				die; */
				 foreach($pdf_arr as $pdf_val){
					 $pdf_amt = "";$db_amt = "";
					if(!empty($pdf_val)) {
							$order_number = substr(trim($pdf_val), 0, 9);
							if(!empty($order_number)) {
							$replaced_string = str_replace($order_number ,'',$pdf_val)."\r\n"; 
						/* 	echo '<pre>';
							print_r(explode("$",$replaced_string)); */
							$exp = explode("$",$replaced_string);
							/* echo '<pre>';
							print_r(explode('/',$exp[0])); */
							$next_exp = explode('/',$exp[0]);
							$amt_offset = $next_exp[2];
							 $current_year = date('Y');
							$length = strlen(substr($current_year , -2 , 2));
							$quantity_length = 1;
							$total_strip_length = $length + $quantity_length;
							$strip_string =  substr($amt_offset,0,$total_strip_length);
							  $pdf_amt = trim(str_replace($strip_string,'',$amt_offset))."\r\n";
							$to = 'kris@kriskellymusic.com'; // note the comma
							//OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
						 //OrdersDemo::find()->where("OrderMainId = '11671841'");
							//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
							$order_status = "";
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
								$order_status = $orderdata->Status;
									
								$orderdata->Paid = date('Y-m-d');
								//$orderdata->Status = 'PAYMENT RECEIVED';
								  $db_amt  =  $orderdata->SalePrice ;
								if ($orderdata->update() !== false) {
									// update successful
									if($pdf_amt != $db_amt){
										/* Send Order Mismatch Email */
										$this->order_mismatch_email($order_number,$pdf_amt,$db_amt,$to);
									}	
									
								} 							
							} else {
								
								if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
								}else {
									/* Send Not Found Email */
									$this->order_not_found_email($order_number,$pdf_amt,$to);
								}
								
								
							}	
								
								
							}
						}	
					
				}	
		
				$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadpdf']);
			}
            
        }

        return $this->render('uploadpdf', ['model' => $model]);
	}
	
	
	public function actionUploadpdfv2(){
	  $model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
				$model->pdfFile->saveAs('uploads/payment-csv/' .$file_name);
				$filename = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				//include ( \Yii::$app->basePath.'/PdfToText-master/PdfToText.phpclass' ) ;
				$pdf    =  new PdfToText ( $filename ) ;
				$pdf_content = $pdf -> Text ;         // 
				$pdf_arr = explode("Direct To You Tickets, Inc.",$pdf_content);

				function trimArray(&$value) 
				{ 
					$value = trim($value); 
				}

				array_walk($pdf_arr, 'trimArray');

				 
				//die; 
				 unset($pdf_arr[0]); 
				 unset($pdf_arr[1]); 
				/*   echo '<pre>';
				print_r($pdf_arr);  */
				//die;
				 foreach($pdf_arr as $pdf_val){
					 $pdf_amt = "";$db_amt = "";
					if(!empty($pdf_val)) {
							echo $order_number = substr($pdf_val, 0, 9);
							if(!empty($order_number)) {
							$replaced_string = str_replace($order_number ,'',$pdf_val)."\r\n"; 
						/* 	echo '<pre>';
							print_r(explode("$",$replaced_string)); */
							$exp = explode("$",$replaced_string);
							/* echo '<pre>';
							print_r(explode('/',$exp[0])); */
							$next_exp = explode('/',$exp[0]);
							$amt_offset = $next_exp[2];
							 $current_year = date('Y');
							$length = strlen(substr($current_year , -2 , 2));
							$quantity_length = 1;
							$total_strip_length = $length + $quantity_length;
							$strip_string =  substr($amt_offset,0,$total_strip_length);
							$pdf_amt = trim(str_replace($strip_string,'',$amt_offset))."\r\n";
							$to = 'kris@kriskellymusic.com'; // note the comma
							//OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
						 //OrdersDemo::find()->where("OrderMainId = '11671841'");
							//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
							$order_status = "";
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
								$order_status = $orderdata->Status;
									
								$orderdata->Paid = date('Y-m-d');
								//$orderdata->Status = 'PAYMENT RECEIVED';
								  $db_amt  =  $orderdata->SalePrice ;
								if ($orderdata->update() !== false) {
									// update successful
									if($pdf_amt != $db_amt){
										/* Send Order Mismatch Email */
										$this->order_mismatch_email($order_number,$pdf_amt,$db_amt,$to);
									}	
									
								} 							
							} else {
								
								if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
								}else {
									/* Send Not Found Email */
									$this->order_not_found_email($order_number,$pdf_amt,$to);
								}
								
								
							}	
								
								
							}
						}	
					
				}	
		
				$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadpdfv2']);
			}
            
        }

        return $this->render('uploadpdfv2', ['model' => $model]);
	}



    public function actionUploadpdfv3(){
      $model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
            if ($model->validate()) {
                $rand_string = rand(0,99999);
                $file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
                $model->pdfFile->saveAs('uploads/payment-csv/' .$file_name);
                $filename = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
                //include ( \Yii::$app->basePath.'/PdfToText-master/PdfToText.phpclass' ) ;
                $pdf    =  new PdfToText ( $filename ) ;
                $pdf_content = $pdf -> Text ;         // 
                //die;
                //$pdf_arr = explode("Direct To You Tickets, Inc.",$pdf_content);
                $pdf_arr = explode("Direct",$pdf_content);

                function trimArray(&$value) 
                { 
                    $value = trim($value); 
                }

                array_walk($pdf_arr, 'trimArray');

                 
                //die; 
                 unset($pdf_arr[0]); 
                 unset($pdf_arr[1]); 
                  /* echo '<pre>';
                print_r($pdf_arr);*/ 
                
                 foreach($pdf_arr as $pdf_val){
                     $pdf_amt = "";$db_amt = "";
                    if(!empty($pdf_val)) {
                             $order_number = substr(trim($pdf_val), 15, 9);

                            
                            if(!empty($order_number)) {
                            $replaced_string = str_replace($order_number ,'',$pdf_val)."\r\n"; 
                            /*echo '<pre>';
                            print_r(explode("$",$replaced_string)); */
                            $exp = explode("$",$replaced_string);
                             /*echo '<pre>';
                            print_r(explode('/',$exp[0])); */
                            $next_exp = explode('/',$exp[0]);
                            


                            $amt_offset = $next_exp[2];
                             $pdf_amt = substr(trim($next_exp[2]), 5, 6);
                            $current_year = date('Y');
                            $length = strlen(substr($current_year , -2 , 2));
                            $quantity_length = 1;
                            $total_strip_length = $length + $quantity_length;
                            $strip_string =  substr($amt_offset,0,$total_strip_length);
                            //$pdf_amt = trim(str_replace($strip_string,'',$amt_offset))."\r\n";

                            
                            
                              //die;
                            $to = 'kris@kriskellymusic.com'; // note the comma
                            //OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
                         //OrdersDemo::find()->where("OrderMainId = '11671841'");
                            //$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();

                             $order_status = "";
                            if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){


                                $order_status = $orderdata->Status;
                                    
                                $orderdata->Paid = date('Y-m-d');
                                //$orderdata->Status = 'PAYMENT RECEIVED';
                                  $db_amt  =  $orderdata->SalePrice ;
                                if ($orderdata->update() !== false) {
                                    // update successful

                                    
                                    if($pdf_amt != $db_amt){
                                        /* Send Order Mismatch Email */
                                        $this->order_mismatch_email($order_number,$pdf_amt,$db_amt,$to);
                                    }   
                                    
                                }

                                else{
                                    
                                }                           
                            } else {

                               
                                
                                if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {  
                                    //echo "completed";

                                }else {

                                    
                                    /* Send Not Found Email */
                                    $this->order_not_found_email($order_number,$pdf_amt,$to);
                                }
                                
                                
                            }
                              
                                
                                
                            }
                        } 
                    
                }   
        
                $base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
                unlink($base_path);
                \Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadpdfv3']);
            }
            
        }

        return $this->render('uploadpdfv3', ['model' => $model]);
    }
	
		public function actionUploadtnpdf(){
			
			
		$model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
				$model->pdfFile->saveAs('uploads/payment-pdf/' .$file_name);
				$filename = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				$path = \Yii::$app->basePath;
				include $path.'/pdfparser-master/vendor/autoload.php';
				
		 
				// Parse pdf file and build necessary objects.
				$parser = new \Smalot\PdfParser\Parser();
				
				$pdf    = $parser->parseFile($filename);
				 
				$text = $pdf->getText();
				// $text = str_replace(array('&', '%', '$'), ' ', $text);
				$tx_arr = explode('%',$text);
		
				unset($tx_arr[0]);
				unset($tx_arr[1]);
				// echo '<pre>';
				// print_r($tx_arr);
				// die;  
				foreach($tx_arr as $text_val) {

					 $pdf_amt = "";$db_amt = "";
					if(!empty($text_val)) {
						
						$textexparr = explode('$',$text_val);	

						$preg_rep = "";$preg_rep2="";$preg_replace_res="";$preg_replace_res22="";
						$preg_rep =  preg_replace('/\s+/', '_', trim($textexparr[2]));
						$preg_replace_res = explode('_',$preg_rep);
						$preg_rep2 =  preg_replace('/\s+/', '_', trim($textexparr[3]));
                        $preg_replace_res2 = explode('_',$preg_rep2);
                        

						$order_number = $preg_replace_res2[2];
						$pdf_amt = $preg_replace_res[0];
						$order_status = "";
							if(!empty($order_number)) {
							$to = 'kris@kriskellymusic.com'; // note the comma
							//OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
						 //OrdersDemo::find()->where("OrderMainId = '11671841'");
							//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
							$order_status = "";
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE')")->one()) !== null){
								$order_status = $orderdata->Status;
									
								$orderdata->Paid = date('Y-m-d');
								//$orderdata->Status = 'PAYMENT RECEIVED';
								  $db_amt  =  $orderdata->SalePrice ;
								if ($orderdata->update() !== false) {
									// update successful
									if($pdf_amt != $db_amt){
										/* Send Order Mismatch Email */
										$this->order_mismatch_email($order_number,$pdf_amt,$db_amt,$to);
									}	
									
								}  
							} else {
								if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
								}else {
									/* Send Not Found Email */
									$this->order_not_found_email($order_number,$pdf_amt,$to);
								}
								
							}		
						  }
						}	
					
				 }	
		
				$base_path = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadtnpdf']);
			}
            
        }

        return $this->render('uploadtnpdf', ['model' => $model]);
	}
	
	
	public function actionUploadtnpricepdf(){
			
			
		$model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
				$model->pdfFile->saveAs('uploads/payment-pdf/' .$file_name);
				$filename = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				$path = \Yii::$app->basePath;
				include $path.'/pdfparser-master/vendor/autoload.php';
				
		 
				// Parse pdf file and build necessary objects.
				$parser = new \Smalot\PdfParser\Parser();
				
				$pdf    = $parser->parseFile($filename);
				 
				$text = $pdf->getText();
				// $text = str_replace(array('&', '%', '$'), ' ', $text);
				$tx_arr = explode('%',$text);
		
				unset($tx_arr[0]);
				unset($tx_arr[1]);
				// echo '<pre>';
				// print_r($tx_arr);
				// die;  
				foreach($tx_arr as $text_val) {

					 $pdf_amt = "";$db_amt = "";
					if(!empty($text_val)) {
						
						$textexparr = explode('$',$text_val);	

						$preg_rep = "";$preg_rep2="";$preg_replace_res="";$preg_replace_res22="";
						$preg_rep =  preg_replace('/\s+/', '_', trim($textexparr[2]));
						$preg_replace_res = explode('_',$preg_rep);
						$preg_rep2 =  preg_replace('/\s+/', '_', trim($textexparr[3]));
						$preg_replace_res2 = explode('_',$preg_rep2);
						$order_number = $preg_replace_res2[2];
						$pdf_amt = $preg_replace_res[0];
							if(!empty($order_number)) {
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
								$orderdata->SalePrice  = $pdf_amt;

									if ($orderdata->update() !== false) {
										// update successful
									}  
								}	
							}
						}	
					
				 }	
		
				$base_path = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadtnpricepdf']);
			}
            
        }

        return $this->render('uploadtnpricepdf', ['model' => $model]);
    }
    
    public function actionUploadticketpdf(){
			
			
		$model = new UploadPdf();
        if (Yii::$app->request->isPost) {
            $model->pdfFile = UploadedFile::getInstance($model, 'pdfFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_pdf_'.$rand_string.'.'.$model->pdfFile->extension;
				$model->pdfFile->saveAs('uploads/payment-pdf/' .$file_name);
				$filename = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				$path = \Yii::$app->basePath;
				include $path.'/pdfparser-master/vendor/autoload.php';
				
		 
				// Parse pdf file and build necessary objects.
				$parser = new \Smalot\PdfParser\Parser();
				$pdf    = $parser->parseFile($filename);
				 
                $text = $pdf->getText();
               // echo $text."<br>"; die;
				// $text = str_replace(array('&', '%', '$'), ' ', $text);
                $tx_arr = explode('Net',$text);
               // $tx_arr = array_filter($tx_arr);
               // $tx_arr = end($tx_arr);

               // echo implode(" ",$tx_arr);
               // die;
               $net_price = array();
               $order_number = array();
                $tx_arr_space = explode('	',$tx_arr[1]);

               // echo '<pre>';
               // print_r($tx_arr_space);

                for ($i = 2;$i<count($tx_arr_space);$i=$i+3) {
                    $myStr =  $tx_arr_space[$i];
                        $tx_arr_space_1 = explode('$',$myStr);
                        $net_price[] = $tx_arr_space_1[2];
                        
                    }

                for ($i = 1;$i<count($tx_arr_space);$i=$i+3) {
                    $myStr =  $tx_arr_space[$i];
                         $result = substr($myStr, 0, 24);
                         $order_number[] = substr($result, 17, 24);
                        
                    }

                  $combined =  array_combine($net_price,$order_number);
                  $combined =  array_filter($combined);

                  $pdf_amt = "";$db_amt = "";

                  $i=0;
                  foreach ($combined as $key => $value):
                  //if($i==0){
                   if(!empty($value)) {
                       
                    $order_number = $value;
                     $pdf_amt = $key; 
                       $order_status = "";
                           if(!empty($order_number)) {
                               
                           $to = 'kris@kriskellymusic.com'; 
                           $order_status = "";

                           if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and `SalePrice` LIKE '%$pdf_amt%' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE')")->one()) !== null){
                               $order_status = $orderdata->Status;

                                $orderdata->Paid = date('Y-m-d');
                               //$orderdata->Status = 'PAYMENT RECEIVED';
                                 $db_amt  =  $orderdata->SalePrice ;
                               if ($orderdata->update() !== false) {
                                   // update successful
                                   if($pdf_amt != $db_amt){
                                       /* Send Order Mismatch Email */
                                       $this->order_mismatch_email($order_number,$pdf_amt,$db_amt,$to);
                                   }	
                               }  
                           } else {
                               if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
                               }else {
                                   /* Send Not Found Email */
                                   //$this->order_not_found_email($order_number,$pdf_amt,$to);
                               }
                               
                           }		
                         }
                       }
                    //}	
                   $i++;
                    endforeach;

				$base_path = \Yii::$app->basePath.'/uploads/payment-pdf/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadticketpdf']);
			}
            
        }

        return $this->render('uploadticketpdf', ['model' => $model]);
	}
	
	public function actionUploadstubhubxlsx(){
		$model = new UploadXlsx();
        if (Yii::$app->request->isPost) {
            $model->xlsxFile = UploadedFile::getInstance($model, 'xlsxFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymentstubhub_'.$rand_string.'.'.$model->xlsxFile->extension;
				$model->xlsxFile->saveAs('uploads/payment-xlsx/' .$file_name);
				$base_path = \Yii::$app->basePath.'/uploads/payment-xlsx/'.$file_name;
				$objPHPExcel = IOFactory::load($base_path);
				$sheet_arr = $objPHPExcel->getActiveSheet()->toArray(null,true,true,true);
				unset($sheet_arr[1],$sheet_arr[2],$sheet_arr[3],$sheet_arr[4]);
				foreach($sheet_arr as $key=>$sheet_val) { 
				$xls_amt = "";$db_amt = "";
					if(!empty($sheet_val)) {	
						$order_no = trim($sheet_val['E']);
						$xls_amt = trim($sheet_val['L']);
						$to = 'kris@kriskellymusic.com'; // note the comma
					if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
						if(empty($orderdata->Paid)) {
							$order_status = $orderdata->Status;
							$orderdata->Paid = date('Y-m-d');
							//$orderdata->Status = 'PAYMENT RECEIVED';
							  $db_amt  =  $orderdata->SalePrice ;
							if ($orderdata->update() !== false) {
								// update successful
								if($xls_amt != $db_amt){
									/* Send Order Mismatch Email */
									$this->order_mismatch_email($order_no,$xls_amt,$db_amt,$to);
								}	
								
							} 
						} 	
					} else {
							/* Send Not Found Email */
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
							}else {
								$this->order_not_found_email($order_no,$xls_amt,$to);
							}
					}	

					} 
						
				}
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Stubhub Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadstubhubxlsx']);
			}
            
        }

        return $this->render('uploadstubhubxlsx', ['model' => $model]);
	}
	
	
	
	
	public function actionUploadtncsv(){
	  $model = new UploadCsv();
        if (Yii::$app->request->isPost) {
            $model->csvFile = UploadedFile::getInstance($model, 'csvFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymenttn_'.$rand_string.'.'.$model->csvFile->extension;
				$model->csvFile->saveAs('uploads/payment-csv/' .$file_name);
				$csv_arr = $this->read_csv($file_name);
				// echo '<pre>';
				// print_r($csv_arr);
				// die;
				unset($csv_arr[0]);
				foreach($csv_arr as $key=>$csv_val) {
					$csv_amt = "";$db_amt = "";
				if(!empty($csv_val)) {	
				 $order_number = $csv_val[0];
				 $intcsv_amt = intval($csv_val[11]);
				 $csv_amt = $csv_val[11];
					$to = 'kris@kriskellymusic.com'; // note the comma
							//OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
						 //OrdersDemo::find()->where("OrderMainId = '11671841'");
							//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
							$order_status = "";
							if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
								$order_status = $orderdata->Status;
								$orderdata->Paid = date('Y-m-d');
								//$orderdata->Status = 'PAYMENT RECEIVED';
								  $db_amt  =  $orderdata->SalePrice ;
								  $intdb_amt = intval($db_amt);
								if ($orderdata->update() !== false) {
									// update successful
									if($intcsv_amt != $intdb_amt){
										/* Send Order Mismatch Email */
										$this->order_mismatch_email($order_number,$csv_amt,$db_amt,$to);
									}	
									
								}  
								
							} else {
								
								if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {
							
								} 
								else {
										/* Send Not Found Email */
										$this->order_not_found_email($order_number,$csv_amt,$to);
								}

							}	
				} 
						
				}	
				$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders TN Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadtncsv']);
			}
            
        }

        return $this->render('uploadtncsv', ['model' => $model]);
	}
	

	public function actionUploadtmcsv(){
	  $model = new UploadCsv();
        if (Yii::$app->request->isPost) {
            $model->csvFile = UploadedFile::getInstance($model, 'csvFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'paymenttm_'.$rand_string.'.'.$model->csvFile->extension;
				$model->csvFile->saveAs('uploads/payment-csv/' .$file_name);
				$csv_arr = $this->read_csv($file_name);
				unset($csv_arr[0]);
				foreach($csv_arr as $key=>$csv_val) {
					$csv_amt = "";$db_amt = "";
				if(!empty($csv_val)) {	
				 $order_no = $csv_val[3];
				 $csv_amt = $csv_val[7];
				 $to = 'kris@kriskellymusic.com'; // note the comma
				 //OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
				 //OrdersDemo::find()->where("OrderMainId = '11671841'");
					//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
					$order_status = "";
					if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
						
						$orderdata->Paid = date('Y-m-d');
						//$orderdata->Status = 'PAYMENT RECEIVED';
						  $db_amt  =  $orderdata->SalePrice ;
						if ($orderdata->update() !== false) {
							// update successful
							if($csv_amt != $db_amt){
								/* Send Order Mismatch Email */
								$this->order_mismatch_email($order_no,$csv_amt,$db_amt,$to);
							}	
							
						}  
						
					} else {
						if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {
							
						 } 
						else {
								/* Send Not Found Email */
								$this->order_not_found_email($order_no,$csv_amt,$to);
							}
					}	
				} 
						
				}	
				$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders TM Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadtmcsv']);
			}
            
        }

        return $this->render('uploadtmcsv', ['model' => $model]);
	}
	
	
	public function actionUploadcsv(){
	  $model = new UploadCsv();
        if (Yii::$app->request->isPost) {
            $model->csvFile = UploadedFile::getInstance($model, 'csvFile');
			if ($model->validate()) {
				$rand_string = rand(0,99999);
				$file_name = 'payment_'.$rand_string.'.'.$model->csvFile->extension;
				$model->csvFile->saveAs('uploads/payment-csv/' .$file_name);
				$csv_arr = $this->read_csv($file_name);
				unset($csv_arr[0],$csv_arr[1],$csv_arr[2],$csv_arr[3]);
				foreach($csv_arr as $key=>$csv_val) {
					$csv_amt = "";$db_amt = "";
				if(!empty($csv_val)) {	
				 $order_no = $csv_val[1];
				 $csv_amt = $csv_val[8];
				 $to = 'kris@kriskellymusic.com'; // note the comma
				 $order_status = "";
				 //OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
				 //OrdersDemo::find()->where("OrderMainId = '11671841'");
					//$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
					if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
						$order_status = $orderdata->Status;		
						$orderdata->Paid = date('Y-m-d');
						//$orderdata->Status = 'PAYMENT RECEIVED';
						  $db_amt  =  $orderdata->SalePrice ;
						if ($orderdata->update() !== false) {
							// update successful
							if($csv_amt != $db_amt){
								/* Send Order Mismatch Email */
								$this->order_mismatch_email($order_no,$csv_amt,$db_amt,$to);
							}	
							
						}
											
					} else {
						
						if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {	
						} else {
								/* Send Not Found Email */
								$this->order_not_found_email($order_no,$csv_amt,$to);
							}
					}	
				} 
						
				}	
				$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
				unlink($base_path);
				\Yii::$app->getSession()->setFlash('success', 'Orders Vivid Payment has been updated to Paid successfully.');
                 return $this->redirect(['orders/uploadcsv']);
			}
            
        }

        return $this->render('uploadcsv', ['model' => $model]);
    }
    

    public function actionUploadmrccsv(){
        $model = new UploadCsv();
          if (Yii::$app->request->isPost) {
              $model->csvFile = UploadedFile::getInstance($model, 'csvFile');
              if ($model->validate()) {
                  $rand_string = rand(0,99999);
                  $file_name = 'paymentmrc_'.$rand_string.'.'.$model->csvFile->extension;
                  $model->csvFile->saveAs('uploads/payment-csv/' .$file_name);
                  $csv_arr = $this->read_csv($file_name);
                  // echo '<pre>';
                  // print_r($csv_arr);
                  // die;
                  unset($csv_arr[0]);
                  foreach($csv_arr as $key=>$csv_val) {
                      $csv_amt = "";$db_amt = "";
                    if(!empty($csv_val)) {	
                                $order_number = $csv_val[0];
                                $intcsv_amt = intval($csv_val[3]);
                                $csv_amt = $csv_val[3];
                                $to = 'kris@kriskellymusic.com'; // note the comma
                                
                                //OrdersDemo::find()->where("OrderMainId = '$order_no' and status IN('WAITING PAYMENT','DELAYED','TO SHIP')")->one();
                                //OrdersDemo::find()->where("OrderMainId = '11671841'");
                                //$order_query = OrdersDemo::find()->where("OrderMainId = '11671841'")->one();
                                $order_status = "";

                                if(($orderdata = Orders::find()->where("OrderMainId = '$order_number' and status IN('WAITING PAYMENT','LINKS TO ADD','TO BUY','TO BUY HANNA','PROBLEM','PRESALE','TO BUY DEEPAK')")->one()) !== null){
                                    $order_status = $orderdata->Status;
                                    $orderdata->Paid = date('Y-m-d');
                                        //$orderdata->Status = 'PAYMENT RECEIVED';
                                    $db_amt  =  $orderdata->SalePrice;
                                    $intdb_amt = intval($db_amt);
                                        if ($orderdata->update() !== false) {
                                            // update successful
                                            if($intcsv_amt != $intdb_amt){
                                                /* Send Order Mismatch Email */
                                                //no need to send miss match email.
                                                //$this->order_mismatch_email($order_number,$csv_amt,$db_amt,$to);
                                            }	
                                            
                                        }  
                                    
                                } else {
                                    
                                    if(($orderdata = Orders::find()->where("OrderMainId = '$order_no' and status IN('COMPLETED','CANCELLED')")->one()) !== null) {
                                
                                    } 
                                    else {
                                            /* Send Not Found Email */
                                            $this->order_not_found_email($order_number,$csv_amt,$to);
                                    }
    
                                }	
                    } 
                          
                  }	
                  $base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
                  unlink($base_path);
                  \Yii::$app->getSession()->setFlash('success', 'Orders Mercury Payment has been updated to Paid successfully.');
                   return $this->redirect(['orders/uploadmrccsv']);
              }
              
          }
  
          return $this->render('uploadmrccsv', ['model' => $model]);
      }

	public function read_csv($file_name){
		$base_path = \Yii::$app->basePath.'/uploads/payment-csv/'.$file_name;
		$file_handle = fopen($base_path, 'r');
		while (!feof($file_handle) ) {
			$line_of_text[] = fgetcsv($file_handle);
		}
		fclose($file_handle);
		return $line_of_text;
	}	
	
	
	/* Send email for not found orders  */
	
	public function order_not_found_email($order_no,$amount,$to){
		// Subject
		$subject = 'Order # '.$order_no.' - Not found in system';

		// Message
		$message = '
		<html>
		<head>
		  <title>Order not found in the system</title>
		</head>
		<body>
		  <p>Hi Admin,</p>
		  <p>Order # '.$order_no.' missing. Payment of $'.$amount.' was not logged in system.</p>
		  <p>Thanks & Regards,<br/>
			Classclassifieds Team
		  </p>
		</body>
		</html>
		';

		// Mail it
		$eol = PHP_EOL;
		$separator = md5(time());
		$contact = "contact@classclassifieds.com";
		$headers = "From: Class Classifieds<" . $contact . ">" . $eol;
		$headers .= "MIME-Version: 1.0" . $eol;
		$headers .= "Content-Type: multipart/mixed; boundary=\"" . $separator . "\"" . $eol;
		$headers .= "Content-Transfer-Encoding: 7bit" . $eol;
		$headers .= "This is a MIME encoded message." . $eol;
		$headers .= "Reply-To: $contact" . $eol;
		// message
		$headers .= "--" . $separator . $eol;
		$headers .= "Content-Type: text/html; charset=\"UTF-8\"" . $eol;
		$headers .= "Content-Transfer-Encoding: 8bit" . $eol;
		@mail($to, $subject, $message, $headers);
	}	
	
	/* Send email for mismatch orders  */
	
	public function order_mismatch_email($order_no,$csv_amt,$db_amt,$to){
		// Subject
		$subject = 'Order # '.$order_no.' - Payment mismatch';

		// Message
		$message = '
		<html>
		<head>
		  <title>Order Payment mismatch</title>
		</head>
		<body>
		  <p>Hi Admin,</p>
		  <p>order # '.$order_no.' you were supposed to receive $'.$db_amt.' but instead you received $'.$csv_amt.'.</p>
		  <p>Thanks & Regards,<br/>
			Classclassifieds Team
		  </p>
		</body>
		</html>
		';

		// Mail it
		$eol = PHP_EOL;
		$separator = md5(time());
		$contact = "contact@classclassifieds.com";
		$headers = "From: Class Classifieds<" . $contact . ">" . $eol;
		$headers .= "MIME-Version: 1.0" . $eol;
		$headers .= "Content-Type: multipart/mixed; boundary=\"" . $separator . "\"" . $eol;
		$headers .= "Content-Transfer-Encoding: 7bit" . $eol;
		$headers .= "This is a MIME encoded message." . $eol;
		$headers .= "Reply-To: $contact" . $eol;
		// message
		$headers .= "--" . $separator . $eol;
		$headers .= "Content-Type: text/html; charset=\"UTF-8\"" . $eol;
		$headers .= "Content-Transfer-Encoding: 8bit" . $eol;
		@mail($to, $subject, $message, $headers);
    }

}