<?php
namespace backend\controllers;
use Yii;
use backend\models\Orders;
use backend\models\OrdersSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use yii\web\Session;
class ReportsController extends Controller
{
    public function behaviors()
    {
        return [
               'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['test'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['profit','payment','oustandingcredit','movetocompleted','dailyordernumber'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }
    
    public function beforeAction($action)
	{
		if (!parent::beforeAction($action)) {
			return false;
		}
		// Check only when the user is logged in
		if (!Yii::$app->user->isGuest) {

			$time = \Yii::$app->session->get('userSessionTimeout');

			if ($time < time()) {
				Yii::$app->user->logout();
			} else {
				\Yii::$app->session->set('userSessionTimeout', time() + Yii::$app->params['sessionTimeoutSeconds']);
				return true;
			}
		} else {
			return true;
		}
	}
	
	 public function actionMovetocompleted(){
        $status=trim($_REQUEST['status']);
		$models = Orders::find()->where("status = 'WAITING PAYMENT' and Paid != ''")->all();  
		 if(!empty($models)){
			foreach($models as $model){          
			   $order_data = Orders::find()
                ->where(['OrderId' => $model->OrderId])
                ->one(); 

                $order_data->Status=$status;
                $order_data->Updated_at=date('Y-m-d H:i:s');
                $order_data->save(false); 
			 }
		 }	
		 echo "succes";
        die;   	
    }
    
     public function actionPayment(){ 
         $models = Orders::find()->where("status = 'WAITING PAYMENT' and Paid != ''")->all();	 
         $notspecified=array();
         $paidamount=$sparkamount=$plumamount=$otheramount=$notspecifiedamount=0;
         if(!empty($models)){
             foreach($models as $model){               
                    if(!empty($model->Cost)) { 
                       $notspecified[$model->OrderId]=$model->Cost; 
                    }            
             }
             $notspecifiedamount=array_sum($notspecified);
             //echo '<pre>';print_r($paid); print_r($spark); print_r($plum); print_r($other); print_r($notspecified); echo '</pre>';
         }
         $data=array();

         $data['NOT SPECIFIED']=$notspecifiedamount;
          return $this->render('payment', [
            'model' => $data,           
        ]);
        
        // 
     }
	 
	     public function actionOustandingcredit(){ 
         $models = Orders::find()->where("status IN('WAITING PAYMENT','Bought')")->all();  
         $notspecified=array();
         $paidamount=$sparkamount=$plumamount=$otheramount=$notspecifiedamount=0;
         if(!empty($models)){
             foreach($models as $model){               
                     if(!empty($model->Cost)) { 
                        $notspecified[$model->OrderId]=$model->Cost; 
                     }            
             }

            $notspecifiedamount=array_sum($notspecified);
             //echo '<pre>';print_r($paid); print_r($spark); print_r($plum); print_r($other); print_r($notspecified); echo '</pre>';
         }
         $data=array();
         $data['NOT SPECIFIED']=$notspecifiedamount;
          return $this->render('oustandingcredit', [
            'model' => $data,           
        ]);
        
        // 
     }
	 
     public function actionProfit(){ 
      ini_set('memory_limit','-1');
       $mysourceorder= $mysource_profit=$mysource_sale=$mysource_cost=array();
         $final_array=array();
         if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }
       //  $query = Orders::find()->where('Status != :status AND Status!=:ss', [':status' => 'DELETED',':ss'=>'TRASH'])->orderBy(['EventDate' => SORT_ASC])->all();  
         $query = Orders::find();  
		 $query->where("status IN('WAITING PAYMENT','COMPLETED')");
         if(!empty($from) && empty($to)) {
              $query->andFilterWhere(['>=', 'OrderDate',$from]);
         }else if(!empty($to) && empty($from)) { 
               $query->andFilterWhere(['<=', 'OrderDate',$to]);
          } else if(!empty($to) && !empty($from)){ 
               $query->andFilterWhere(['>=', 'OrderDate', $from])
                ->andFilterWhere(['<=', 'OrderDate', $to]);
          }else{
              $query->andFilterWhere(['=', 'OrderDate', '1800-01-01']);
          }
           $records=$query->all();
          if(!empty($records)){
              $records=$query->all();
             
              foreach($records as $signlerecord){
                  if($signlerecord->Status!="TRASH" && $signlerecord->Status!="DELETED" && $signlerecord->Status!="CANCELLED") { 
                        if(!empty($signlerecord->Cost)) {
                          $mysource_cost[$signlerecord->Source][]=$signlerecord->Cost;
                          $mysource_sale[$signlerecord->Source][]=$signlerecord->SalePrice;
                          $mysource_profit[$signlerecord->Source][]=$signlerecord->Profit;
                        }     
                        $mysourceorder[$signlerecord->Source][]=$signlerecord->OrderId;
                }               
              }
             
              if(!empty($mysource_cost)) {
                  foreach($mysource_cost as $key=>$cost) {
                      $final_array[$key]['cost']=array_sum($cost);                      
                  }
              }
              if(!empty($mysource_sale)) {
                  foreach($mysource_sale as $key1=>$sale) {
                      $final_array[$key1]['sale']=array_sum($sale);                      
                  }
              }
              if(!empty($mysource_profit)){
                  foreach($mysource_profit as $key2=>$profit) {                   
                      $final_array[$key2]['profit']=array_sum($profit);                      
                  }
              }  
              if(!empty($mysourceorder)) {
                  foreach($mysourceorder as $key3=>$order) {                   
                      $final_array[$key3]['myorder']=count($order);                      
                  }
              }
             
          }
          
         
         
         return $this->render('profit', [
            'from' => $from, 
            'to' => $to, 
            'finaldata' => $final_array, 
             
        ]);
         
     }
	 
	 
	  public function actionDailyordernumber(){ 
      ini_set('memory_limit','-1');
       $mysourceorder= $mysource_profit=$mysource_sale=$mysource_cost=array();
         $final_array=array();
         if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }
		 $orders = array();
		 $orders = Orders::find()->select(['OrderDate', 'sum(Profit) as total_profit' ,'COUNT(OrderDate) AS total_orders'])->where("OrderDate IN (SELECT OrderDate FROM `orders` where OrderDate >= '$from' and OrderDate <= '$to' group by OrderDate)")->groupBy(['OrderDate'])->asArray()->all();
         return $this->render('dailyordernumber', [
            'from' => $from, 
            'to' => $to, 
            'finaldata' => $orders, 
             
        ]);
         
     }
	 
	 
	 
}
?>