<?php

namespace backend\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\models\Orders;

/**
 * OrdersSearch represents the model behind the search form about `app\models\Orders`.
 */
class OrdersSearch extends Orders
{
    /**
     * @inheritdoc
     */
    
    public function rules()
    {
        return [
            [['OrderId'], 'integer'],
            [['OrderMainId','OrderDate', 'Quantity', 'Event', 'Venue', 'Section', 'Row', 'EventDate', 'Cost', 'SalePrice', 'Profit', 'Source', 'Notes', 'Status', 'message_id', 'Updated_at', 'Created_at','Link' ,'Purchased' , 'Paid' , 'UpdateBy','DeliveryMethod','Covid'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where('Status != :status', [':status' => 'DELETED']);   
        } else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';	
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';		
			}	
			 $query = Orders::find()->where('Status != :status', [':status' => 'DELETED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where('Status != :status', [':status' => 'DELETED'])->orderBy('EventDate ASC');  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 100,
            ],
        ]);
        

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
            ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
            ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
            ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
            ->andFilterWhere(['like', 'Covid', $this->Covid]);
            
            //var_dump($query->createCommand()->rawSql);

        return $dataProvider;
    }
    
     public function searchbuy($params,$tobuystatus='TO BUY')
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => $tobuystatus]);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';	
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => $tobuystatus])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => $tobuystatus])->orderBy('EventDate ASC,Event ASC');  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
             ->andFilterWhere(['like', 'Covid', $this->Covid]);
        return $dataProvider;
    }
    public function searchwaiting($params)
    {      
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'WAITING PAYMENT']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'WAITING PAYMENT'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'WAITING PAYMENT'])->orderBy(['Updated_at' => SORT_DESC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    public function searchpayment($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PAYMENT RECEIVED']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'PAYMENT RECEIVED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'PAYMENT RECEIVED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
		->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
     public function searchcompleted($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'COMPLETED']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'COMPLETED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'COMPLETED'])->orderBy(['Updated_at' => SORT_DESC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
		->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
    public function searchdelayed($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'DELAYED']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}		
			 $query = Orders::find()->where(['Status' => 'DELAYED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'DELAYED'])->orderBy(['Updated_at' => SORT_DESC]);             
            //->orderBy(['EventDate' => SORT_ASC]); 
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
		->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
     public function searchtoship($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'TO SHIP']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'TO SHIP'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'TO SHIP'])->orderBy(['Updated_at' => SORT_DESC]);
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
		->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
    public function searchpresale($params)
    {      

        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PRESALE']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'PRESALE'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'PRESALE'])->orderBy('EventDate ASC,Event ASC');  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
		->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
     public function searchsoldout($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'SOLD OUT']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}		
			 $query = Orders::find()->where(['Status' => 'SOLD OUT'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'SOLD OUT'])->orderBy('EventDate ASC,Event ASC');  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    public function searchproblem($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'PROBLEM']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'PROBLEM'])->orderBy($sort_order);  
		}else{
            //$query = Orders::find()->where(['Status' => 'PROBLEM'])->orderBy(['EventDate' => SORT_ASC]); //commented-08-june-2021//
            $query = Orders::find()->where(['Status' => 'PROBLEM'])->orderBy('EventDate ASC,Event ASC');   
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
    public function searchbought($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'BOUGHT']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'BOUGHT'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'BOUGHT'])->orderBy('EventDate ASC,Event ASC'); 
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
	
	public function searchpostponed($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'POSTPONED']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'POSTPONED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'POSTPONED'])->orderBy('EventDate ASC,Event ASC'); 
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
	
	public function searchworking($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'WORKING']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'WORKING'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'WORKING'])->orderBy('EventDate ASC,Event ASC'); 
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
	
	public function searchdontbuyyet($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'DONT BUY YET']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'DONT BUY YET'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'DONT BUY YET'])->orderBy('EventDate ASC,Event ASC');   
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
	
	
    public function searchcancelled($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'CANCELLED']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'CANCELLED'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'CANCELLED'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source]) 
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
    
    public function searchLinks($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'LINKS TO ADD']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where(['Status' => 'LINKS TO ADD'])->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where(['Status' => 'LINKS TO ADD'])->orderBy(['EventDate' => SORT_ASC,'Event'=>SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
	
    public function event_date_search($params)
    {      
        if(isset($_REQUEST['from']) && !empty($_REQUEST['from'])){ 
             $from=trim($_REQUEST['from']);
         }else{
             $from="";
         }
         
         if(isset($_REQUEST['to']) && !empty($_REQUEST['to'])){
             $to=trim($_REQUEST['to']);
         }else{
             $to="";
         }

        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where("EventDate IN (SELECT EventDate FROM `orders` where EventDate >= '$from' and EventDate <= '$to')");   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
			if($_GET['sorting'] == '-secondary'){
				$sort_order = 'Priority DESC,EventDate ASC,Event ASC';		
			} else {
				$sort_order = 'Priority ASC,EventDate DESC,Event ASC';			
			}	
			 $query = Orders::find()->where("EventDate IN (SELECT EventDate FROM `orders` where EventDate >= '$from' and EventDate <= '$to')")->orderBy($sort_order);  
		}else{
            $query = Orders::find()->where("EventDate IN (SELECT EventDate FROM `orders` where EventDate >= '$from' and EventDate <= '$to')")->orderBy('EventDate ASC,Event ASC');
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
			->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
			  ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
			 ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			 ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }


    public function searchTrash($params)
    {      
       
        if(isset($_GET['sort']) && !empty($_GET['sort'])) {
            $query = Orders::find()->where(['Status' => 'TRASH']);   
        }else if(isset($_GET['sorting']) && !empty($_GET['sorting'])){
            if($_GET['sorting'] == '-secondary'){
                $sort_order = 'Priority DESC,EventDate ASC,Event ASC';      
            } else {
                $sort_order = 'Priority ASC,EventDate DESC,Event ASC';          
            }   
             $query = Orders::find()->where(['Status' => 'TRASH'])->orderBy($sort_order);  
        }else{
            $query = Orders::find()->where(['Status' => 'TRASH'])->orderBy(['EventDate' => SORT_ASC]);  
        }
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 500,
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere([
            'OrderId' => $this->OrderId,
            'OrderMainId' => $this->OrderMainId,
            'Updated_at' => $this->Updated_at,
            'Created_at' => $this->Created_at,
        ]);

        $query->andFilterWhere(['like', 'OrderDate', $this->OrderDate])
            ->andFilterWhere(['like', 'UpdateBy', $this->UpdateBy])
            ->andFilterWhere(['like', 'Quantity', $this->Quantity])
            ->andFilterWhere(['like', 'Event', $this->Event])
            ->andFilterWhere(['like', 'Venue', $this->Venue])
            ->andFilterWhere(['like', 'Section', $this->Section])
            ->andFilterWhere(['like', 'Row', $this->Row])
            ->andFilterWhere(['like', 'EventDate', $this->EventDate])
            ->andFilterWhere(['like', 'Cost', $this->Cost])
            ->andFilterWhere(['like', 'SalePrice', $this->SalePrice])
            ->andFilterWhere(['like', 'Profit', $this->Profit])
            ->andFilterWhere(['like', 'Source', $this->Source])
            ->andFilterWhere(['like', 'Notes', $this->Notes])
            ->andFilterWhere(['like', 'Status', $this->Status])
                 ->andFilterWhere(['like', 'Link', $this->Link])
            ->andFilterWhere(['like', 'message_id', $this->message_id])
              ->andFilterWhere(['like', 'Purchased', $this->Purchased])
            ->andFilterWhere(['like', 'Paid', $this->Paid])
             ->andFilterWhere(['like', 'DeliveryMethod', $this->DeliveryMethod])
			  ->andFilterWhere(['like', 'Covid', $this->Covid]);

        return $dataProvider;
    }
}
