<?php

use yii\helpers\Html;
use yii\grid\GridView;
use backend\models\Orders;
use yii\web\Request;
use yii\helpers\Url;
use yii\web\View;
/* @var $this yii\web\View */
/* @var $searchModel app\models\OrdersSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$action = Yii::$app->controller->action->id; 


if($action=="bought"){
    $this->title = "Orders Bought";  
}else{
$this->title = 'Orders';
}
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
     #user-grid {overflow:auto}
    .table>caption+thead>tr:first-child>td, .table>caption+thead>tr:first-child>th, .table>colgroup+thead>tr:first-child>td, .table>colgroup+thead>tr:first-child>th, .table>thead:first-child>tr:first-child>td, .table>thead:first-child>tr:first-child>th{
        color:#398EC6
    }
     .form-control{padding: 0px !important}
    .alert{margin-top: 10px; float: left; width: 100%; clear:both;}
    .table > thead > tr > td.danger, .table > tbody > tr > td.danger, .table > tfoot > tr > td.danger, .table > thead > tr > th.danger, .table > tbody > tr > th.danger, .table > tfoot > tr > th.danger, .table > thead > tr.danger > td, .table > tbody > tr.danger > td, .table > tfoot > tr.danger > td, .table > thead > tr.danger > th, .table > tbody > tr.danger > th, .table > tfoot > tr.danger > th{
        background: #f4eca9 !important
    }
</style>

<div class="orders-index">
    <div class="col-md-10">
<div style="overflow:auto;">
    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?php //echo Html::a('Create Orders', ['create'], ['class' => 'btn btn-success']) ?>
       
         <?= Html::a('Refresh', ['index'], ['class' => 'pull-right btn btn-success']) ?>
        <?php 
         $count = $dataProvider->getCount();
           if(!empty($count)) { ?>
        <a class="pull-left btn btn-success" href="<?php echo  Url::to(['orders/csv','status'=>$action]); //echo Yii::$app->request->url.'&action=csv'; ?>">Export CSV</a>        
   
        <span class="pull-right">
        <?php  
        
        echo Html::dropDownList('changestatus','', Orders::getstatus(),['prompt'=>'Please Select Status','id'=>'changestatus','class'=>'pull-left']);
        ?>
            <?php echo Html::a('Move', 'javascript:void(0)', ['class' => 'btn btn-primary pull-left', 'onclick'=>'del($("#user-grid").yiiGridView("getSelectedRows"))' ]); ?>
           
        </span>
 <?php } ?>
     
    </p>
     <?php if (Yii::$app->session->hasFlash('success')): ?>
        <div class="alert alert-success">
             <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            <?php echo Yii::$app->session->getFlash('success'); ?>
        </div>
     <?php endif; ?>
    <?php if (Yii::$app->session->hasFlash('error')): ?>
        <div class="alert alert-error">
             <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
            <?php echo Yii::$app->session->getFlash('error'); ?>
        </div>
     <?php endif; ?>

   <?php if(Yii::$app->user->identity->Role!='user') { ?>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => ''],
        'id'=>'user-grid',
        'rowOptions' => function ($model, $index, $widget, $grid){ 
        if($model->Profit>=0){
                 return ['class' => 'info'];
            }else if($model->Profit<0){
                 return ['class' => 'danger'];
            }
          },
        'columns' => [
            [
            'class' => 'yii\grid\CheckboxColumn',      
            ],
           // ['class' => 'yii\grid\SerialColumn'],
          
          //  'OrderId',
            //'OrderDate',
            [  
              'label'=>'Order Date',    
              'attribute'=>'OrderDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['OrderDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[OrderDate]',
                'attribute'=>'OrderDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control','autocomplete' => 'off'
                ],
            ]), 
            ],
            'OrderMainId',
           
             [
                'attribute'=>'Quantity',
                'label'=>'Q',
                'value'=>function($data){           
                    return $data->Quantity;                    
                   },
            ],
            'Event',
            'Venue',
            'Section',
            'Row',            
             //'EventDate',
             [  
              'label'=>'Event Date',    
              'attribute'=>'EventDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['EventDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[EventDate]',
                'attribute'=>'EventDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control','autocomplete' => 'off'
                ],
            ]), 
            ],
            [
                'attribute'=>'Cost',
                'label'=>'Cost',
                'value'=>function($data){ 
                       if(!empty($data->Cost)) {
                           return "$". number_format($data->Cost,2);                           
                       }
                    return ' ';                     
                   },
            ],
            [
                'attribute'=>'SalePrice',
                'label'=>'Sale Price',
                'value'=>function($data){ 
                       if(!empty($data->SalePrice)) {
                           return "$". number_format($data->SalePrice,2);    
                           //return "$".$data->SalePrice;      
                       }
                    return ' ';                       
                   },
            ],
            [
                'attribute'=>'Profit',
                'label'=>'Profit',
                'value'=>function($data){ 
                       if(!empty($data->Profit)) {
                           if($data->Profit>=0){
                            return "$". number_format($data->Profit,2);  
                           }else{
                                return "-".str_replace("-","$",number_format($data->Profit,2));  
                           }    
                       }
                    return ' ';                     
                   },
            ],
            // 'SalePrice',
            // 'Profit',
             'Source',
             [
                'attribute'=>'CreditCard',
                'filter'=> Orders::getcards(),
                'value'=>function($data){           
                            if(!empty($data->CreditCard)){
                                   return $data->CreditCard;            
                              }else{
                                  return '';  
                              }           
                   },
            ],
            [
                'attribute'=>'Link',  
                      'label'=>'Link',
                'format' => 'raw',
            'value'=>function ($data) {
             if($data->Link){
             return Html::a('Link', $data->Link, [
                         'title' => 'Link',
                         'target' => '_blank'
             ]);
                 }
                 else{
                      return '';
                 }
                 
             },
         ],         
             'DeliveryMethod', 
             'Notes:ntext',   
             
            [
                'attribute'=>'UpdateBy',
                'label'=>'Edited',
                'value'=>function($data){  
          $usernamearr =  explode(' ',$data->UpdateBy);
                    return $usernamearr[0][0].' '.$usernamearr[1][0];                    
                   },
            ],
            [  
                'label'=>'Purchased',    
                'attribute'=>'Purchased',
                'value'=> function($data){       
               // echo '<pre>'; print_r($data['Purchased']); echo '</pre>';
                          if($data['Purchased']!=""){
                                    return  date("m/d/Y",strtotime($data['Purchased']));
                          }else{
                              return ' ';
                          }
                  },  
                  'filter' => \yii\jui\DatePicker::widget([
                  'model'=>$searchModel,
                  'name'=>'TasksSearch[Purchased]',
                  'attribute'=>'Purchased',
                  'dateFormat' => 'yyyy-MM-dd',
                  'options'=>[
                      'class'=>'form-control','autocomplete' => 'off'
                  ],
              ]), 
              ], 
            [  
            'label'=>'Paid',    
            'attribute'=>'Paid',
            'value'=> function($data){       
           // echo '<pre>'; print_r($data['Paid']); echo '</pre>';
                      if($data['Paid']!=""){
                                return  date("m/d/Y",strtotime($data['Paid']));
                      }else{
                          return ' ';
                      }
              },  
              'filter' => \yii\jui\DatePicker::widget([
              'model'=>$searchModel,
              'name'=>'TasksSearch[Paid]',
              'attribute'=>'Paid',
              'dateFormat' => 'yyyy-MM-dd',
              'options'=>[
                  'class'=>'form-control','autocomplete' => 'off'
              ],
          ]), 
          ],    
         
             [
                'attribute'=>'Status',
                 'filter'=> Orders::getstatus(),
                 'value'=>function($data){           
                     if(!empty($data->Status)) {
                             return $data->Status; 
                        }else{
                            return ' ';    
                        }         
                    },
            ],      

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{update} {delete}',
            ],
        ],
]); }else{ ?>
    
 <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
     'formatter' => ['class' => 'yii\i18n\Formatter','nullDisplay' => ''],
        'id'=>'user-grid',
        'rowOptions' => function ($model, $index, $widget, $grid){ 
            if($model->Profit>=0){
                     return ['class' => 'info'];
                }else if($model->Profit<0){
                     return ['class' => 'danger'];
                }
          },
        'columns' => [
            [
            'class' => 'yii\grid\CheckboxColumn',      
            ],
           // ['class' => 'yii\grid\SerialColumn'],
          
          //  'OrderId',
           // 'OrderDate',
            [  
              'label'=>'Order Date',    
              'attribute'=>'OrderDate',
              'value'=> function($data){               
                        return  date("m/d/Y",strtotime($data['OrderDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[OrderDate]',
                'attribute'=>'OrderDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control','autocomplete' => 'off'
                ],
            ]), 
            ],
            'OrderMainId',
           
             [
                'attribute'=>'Quantity',
                'label'=>'Q',
                'value'=>function($data){           
                    return $data->Quantity;                    
                   },
            ],
            'Event',
            'Venue',
            'Section',
            'Row',            
             //'EventDate',
            [  
              'label'=>'Event Date',    
              'attribute'=>'EventDate',
              'value'=> function($data){                  
                        return  date("m/d/Y",strtotime($data['EventDate']));
                },  
                'filter' => \yii\jui\DatePicker::widget([
                'model'=>$searchModel,
                'name'=>'TasksSearch[EventDate]',
                'attribute'=>'EventDate',
                'dateFormat' => 'yyyy-MM-dd',
                'options'=>[
                    'class'=>'form-control','autocomplete' => 'off'
                ],
            ]), 
            ],
             [
                'attribute'=>'Cost',
                'label'=>'Cost',
                'value'=>function($data){ 
                       if(!empty($data->Cost)) {
                           return "$". number_format($data->Cost,2);     
                           //return "$".$data->Cost;      
                       }
                    return '';                    
                   },
            ],
            // 'SalePrice',
             //'Profit',
             'Source',
             [
                'attribute'=>'CreditCard',
                'filter'=> Orders::getcards(),
                'value'=>function($data){           
                     if(!empty($data->CreditCard)){
                            return $data->CreditCard;            
                       }else{
                           return '';  
                       }        
                   },
            ],
            [
                'attribute'=>'Link',  
                      'label'=>'Link',
                'format' => 'raw',
            'value'=>function ($data) {
             if($data->Link){
             return Html::a('Link', $data->Link, [
                         'title' => 'Link',
                         'target' => '_blank'
             ]);
                 }
                 else{
                      return '';
                 }
                 
             },
         ],   
         'DeliveryMethod',     
            
             'Notes:ntext',
             [
                'attribute'=>'Status',
                 'filter'=> Orders::getstatus(),
                 'value'=>function($data){           
                        if(!empty($data->Status)) {
                                 return $data->Status; 
                            }else{
                                return ' ';    
                            }            
                    },
            ],
            [
                'attribute'=>'UpdateBy',
                'label'=>'Edited',
                'value'=>function($data){  
          $usernamearr =  explode(' ',$data->UpdateBy);
                    return $usernamearr[0][0].' '.$usernamearr[1][0];                    
                   },
            ], 
            [  
                'label'=>'Purchased',    
                'attribute'=>'Purchased',
                'value'=> function($data){       
               // echo '<pre>'; print_r($data['Purchased']); echo '</pre>';
                          if($data['Purchased']!=""){
                                    return  date("m/d/Y",strtotime($data['Purchased']));
                          }else{
                              return ' ';
                          }
                  },  
                  'filter' => \yii\jui\DatePicker::widget([
                  'model'=>$searchModel,
                  'name'=>'TasksSearch[Purchased]',
                  'attribute'=>'Purchased',
                  'dateFormat' => 'yyyy-MM-dd',
                  'options'=>[
                      'class'=>'form-control','autocomplete' => 'off'
                  ],
              ]), 
              ],          

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{update} {delete}',
            ],
        ],
]); }
?>
</div>
</div>
</div>
<?php
 $this->registerJs("

$('#user-grid tr').each(function(index, tr) {
    var lines = $('td', tr).map(function(index, td) {
       
      if(index==1){
        if($(td).text()=='12/31/1969'){
          $(td).text('');
        }
         
      }
    
    });   

});

var leavesearchcreated_at = $('#orderssearch-orderdate').val();   

if(leavesearchcreated_at =='1970-01-01'){
$('#orderssearch-orderdate').val('');
}
if(leavesearchcreated_at =='1969-12-31'){
$('#orderssearch-orderdate').val('');
}

var leavesearchcreated_at = $('#orderssearch-eventdate').val();   
if(leavesearchcreated_at =='1970-01-01'){
$('#orderssearch-eventdate').val('');
}
if(leavesearchcreated_at =='1969-12-31'){
$('#orderssearch-eventdate').val('');
}

  function del(id){  
  
var error='flase';
if(jQuery.trim(id)==''){
    alert('Please select atleast one record!');
    error='true';
}

if(jQuery('#changestatus').val()==''){
  alert('Please select Status to move!');
    error='true';
}
//alert(error);
 if(error=='flase'){
  if(confirm('Are you sure to Move records?')==true){ 
        $.ajax({
                                        type     :'POST',
                                        cache    :false,
                                        url: '".yii\helpers\Url::to(['orders/move'])."',
                                        data     :{
                                            'id': id,
                                            'status':jQuery('#changestatus').val(),
                                        },
                                        success  : function(response) {                                    
                                          location.reload();                              
                                        }                            
                                    });

        }
    }
                         
}





            ",View::POS_END); 
 ?>